/*
 * 作成日: 2005/02/08
 */
package bakusen.deathmatch;

import bakusen.common.BStage;
import bakusen.common.Body;
import bakusen.common.EventHandler;
import bakusen.math.BPolygon;
import bakusen.math.BVector2d;

/**
 * @author cattaka
 */
public class BodyItemSpawner extends Body
{
	public static int ACTION_SPAWN_SOMETHING = 0;
	
	public BodyItemSpawner()
	{
		setType(BStageDeathMatch.ITEM_SPAWNER);
		enableState(Body.INVISIBLE);
		setPolygon(new BPolygon());
	}
	
	public boolean hasName()
	{
		return false;
	}
	public boolean hasVariableBPolygon()
	{
		return false;
	} 
	
	public void eventAction(EventHandler eventHandler, BStage bstage, BVector2d position, int action)
	{
		if (action == ACTION_SPAWN_SOMETHING)
		{
			BodyItem body = new BodyItem();
			float r = Math.random();
			if (r < 1d/3d)
				body.setOption(BodyItem.OPTION_TYPE, BodyMan.OPTION_FIRE);
			else if (r < 2d/3d)
				body.setOption(BodyItem.OPTION_TYPE, BodyMan.OPTION_SPEED);
			else
				body.setOption(BodyItem.OPTION_TYPE, BodyMan.OPTION_BOMS);
			
			//body.setParent(this);
			body.setPosition(getPosition());
			
			long currenttime = bstage.getCurrentTime();
			eventHandler.add(currenttime, currenttime, body);
		}
	}
}
