/*
 * 作成日: 2005/01/19
 */
package bakusen.client;

import java.awt.Graphics;

import bakusen.common.Body;
import bakusen.math.BVector2d;

/**
 * @author cattaka
 */
abstract public class ClientBody extends Body
{
	private CharacterImage characterImage;
	private int imageMode = CharacterImage.DOWN;
	private long lastMessageChange;
	private String message = "";
	
	public CharacterImage getCharacterImage()
	{
		return characterImage;
	}
	public void setCharacterImage(CharacterImage characterImage)
	{
		if (characterImage == null)
			throw new NullPointerException();
		this.characterImage = characterImage;
	}
	abstract public void drawCharacter(Graphics g, long currenttime);
	public int getImageMode()
	{
		BVector2d v = getVelocity();
		if (v.x != 0 && v.y != 0)
		{
			if (imageMode == CharacterImage.RIGHT)
				imageMode = CharacterImage.MOVERIGHT;
			else if (imageMode == CharacterImage.LEFT)
				imageMode = CharacterImage.MOVELEFT;
			else if (imageMode == CharacterImage.UP)
				imageMode = CharacterImage.MOVEUP;
			else if (imageMode == CharacterImage.DOWN)
				imageMode = CharacterImage.MOVEDOWN;
		}else
		{
			if (v.x > 0)
				imageMode = CharacterImage.MOVERIGHT;
			else if (v.x < 0)
				imageMode = CharacterImage.MOVELEFT;
			else if (v.y > 0)
				imageMode = CharacterImage.MOVEDOWN;
			else if (v.y < 0)
				imageMode = CharacterImage.MOVEUP;
			else if (imageMode == CharacterImage.MOVERIGHT)
				imageMode = CharacterImage.RIGHT;
			else if (imageMode == CharacterImage.MOVELEFT)
				imageMode = CharacterImage.LEFT;
			else if (imageMode == CharacterImage.MOVEUP)
				imageMode = CharacterImage.UP;
			else if (imageMode == CharacterImage.MOVEDOWN)
				imageMode = CharacterImage.DOWN;
		}
		return imageMode;
	}
	public String getMessage()
	{
		return message;
	}
	public void setMessage(long lastMessageChange, String message)
	{
		this.lastMessageChange = lastMessageChange;
		this.message = message;
	}
	public long getLastMessageChange()
	{
		return lastMessageChange;
	}
}
