package bakutan.client;
import graphtool.GraphView;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.zip.GZIPInputStream;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;

import neuralnetwork.NeuralNetwork;

/*
 * 作成日: 2006/11/24
 *
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */

public class AiLearningTool extends JApplet implements ActionListener,ChangeListener
{
    public static final int DEFAULT_REPEAT = 1000;
//    public static final int DEFAULT_LAYERS = 5;
//    public static final int DEFAULT_NODES = 50;
    public static final double DEFAULT_LEANINGRATE = 0.001;
    public static final int BAR_WIDTH = 10;
    public static final int DEFAULT_GRAPH_WIDTH = 500;
    public static final String DEFAULT_LAYOUT = "200, 100, 50";

    NeuralNetwork neuralNetwork;

    RecFilter recFilter = new RecFilter();
    NNFilter nnFilter = new NNFilter();
    JFileChooser fileChooser;
    double[][] orgInputData = new double[0][0];
    double[][] orgDesiredData = new double[0][0];
    double[] orgDesiredMin = new double[0];
    double[] orgDesiredMax = new double[0];
    BufferedImage org;
    GraphView orgGraph;
    JTextField repeatField = new JTextField("" + DEFAULT_REPEAT);
    JTextField rateField = new JTextField(""+ DEFAULT_LEANINGRATE);
    JTextField threadNumField = new JTextField("1");
    JTextField layerLayoutField = new JTextField(DEFAULT_LAYOUT);
    JButton resetButton = new JButton("reset");
    JButton learnButton = new JButton("learn");
    JButton stopButton = new JButton("stop");
    JButton drawButton = new JButton("draw");
    JProgressBar errorBar = new JProgressBar();
    JProgressBar progressBar = new JProgressBar();
    JSpinner drawGraphPageSpinner = new JSpinner();
    JCheckBox drawGraphCheck = new JCheckBox("Draw graph", true);
    int drawGraphPage = 0;
    File workDir = null;
    
    int inputNeuronNum = 1;
    int outputNeuronNum = 1;
    
    LearnThread learnThread = null;
    
    public AiLearningTool()
    {
        super();
        reset();
        
        orgGraph = new GraphView();
        makeLayout();
    }
    public AiLearningTool(File workdir)
    {
        super();
        this.workDir = workdir;
        if (workDir != null)
        {
            fileChooser = new JFileChooser(workDir);
            fileChooser.setFileHidingEnabled(false);
        }
        reset();
        
        orgGraph = new GraphView();
        makeLayout();
    }
    private void makeLayout()
    {
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        //GridLayout gl = new GridLayout(2,3);
        setLayout(gbl);
        
        JMenuBar menuBar = new JMenuBar();
        JMenu fileMenu = new JMenu("File");
        JMenuItem openMenu = new JMenuItem("open");
        JMenuItem openNetworkMenu = new JMenuItem("open_network");
        JMenuItem saveNetworkMenu = new JMenuItem("save_network");
        fileMenu.add(openMenu);
        fileMenu.add(openNetworkMenu);
        fileMenu.add(saveNetworkMenu);
        openMenu.addActionListener(this);
        openNetworkMenu.addActionListener(this);
        saveNetworkMenu.addActionListener(this);
        if (workDir != null)
            menuBar.add(fileMenu);

//        JMenu sampleMenu = new JMenu("Sample");
//        JMenuItem sample1item = new JMenuItem("sample1");
//        JMenuItem sample2item = new JMenuItem("sample2");
//        JMenuItem sample3item = new JMenuItem("sample3");
//        JMenuItem sample4item = new JMenuItem("sample4");
//        sample1item.addActionListener(this);
//        sample2item.addActionListener(this);
//        sample3item.addActionListener(this);
//        sample4item.addActionListener(this);
//        sampleMenu.add(sample1item);
//        sampleMenu.add(sample2item);
//        sampleMenu.add(sample3item);
//        sampleMenu.add(sample4item);
//        menuBar.add(sampleMenu);
        
        setJMenuBar(menuBar);
        
        JScrollPane orgGraphPane = new JScrollPane(orgGraph);
        orgGraphPane.setSize(300,300);
        gbc.weightx = 1;
        gbc.weighty = 1;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridwidth = 4;
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbl.setConstraints(orgGraphPane,gbc);
        gbc.gridx = 2;
        getContentPane().add(orgGraphPane);
        
        gbc.weightx = 0;
        gbc.weighty = 0;
        gbc.gridwidth = 1;
        gbc.gridy = 2;
        gbc.gridx = 0;
        JLabel layerLayoutLabel = new JLabel("Layer layout");
        JLabel threadNumLabel = new JLabel("Number of Thread");
        JLabel learnRepeatNumLabel = new JLabel("Learn repeat");
        JLabel learnRateLabel = new JLabel("Learning rate");
        gbc.gridy = 2;
        gbl.setConstraints(layerLayoutLabel,gbc);
        gbc.gridy = 3;
        gbl.setConstraints(threadNumLabel,gbc);
        gbc.gridy = 4;
        gbl.setConstraints(learnRateLabel,gbc);
        gbc.gridy = 5;
        gbl.setConstraints(learnRepeatNumLabel,gbc);
        getContentPane().add(layerLayoutLabel);
        getContentPane().add(threadNumLabel);
        getContentPane().add(learnRateLabel);
        getContentPane().add(learnRepeatNumLabel);
        
        gbc.weightx = 1;
        gbc.gridx = 1;
        gbc.gridy = 2;
        gbl.setConstraints(layerLayoutField,gbc);
        gbc.gridy = 3;
        gbl.setConstraints(threadNumField,gbc);
        gbc.gridy = 4;
        gbl.setConstraints(rateField,gbc);
        gbc.gridy = 5;
        gbl.setConstraints(repeatField,gbc);
        getContentPane().add(layerLayoutField);
        getContentPane().add(threadNumField);
        getContentPane().add(rateField);;
        getContentPane().add(repeatField);
                
        JLabel drawGraphPageLabel = new JLabel("page of Graph");
        gbc.weightx = 0;
        gbc.gridy = 1;
        gbc.gridx = 0;
        gbl.setConstraints(drawGraphCheck,gbc);
        gbc.gridx = 1;
        gbl.setConstraints(drawGraphPageLabel,gbc);
        gbc.gridx = 2;
        gbl.setConstraints(drawGraphPageSpinner,gbc);
        drawGraphCheck.setActionCommand("drawGraphCheck");
        drawGraphCheck.addActionListener(this);
        drawGraphPageSpinner.addChangeListener(this);
        getContentPane().add(drawGraphCheck);
        getContentPane().add(drawGraphPageSpinner);
        getContentPane().add(drawGraphPageLabel);
        
        gbc.gridx = 2;
        gbc.gridy = 2;
        gbl.setConstraints(resetButton,gbc);
        gbc.gridy = 3;
        gbl.setConstraints(learnButton,gbc);
        gbc.gridy = 4;
        gbl.setConstraints(stopButton,gbc);
        gbc.gridy = 5;
        gbl.setConstraints(drawButton,gbc);
        resetButton.addActionListener(this);
        learnButton.addActionListener(this);
        stopButton.addActionListener(this);
        drawButton.addActionListener(this);
        getContentPane().add(resetButton);
        getContentPane().add(learnButton);
        getContentPane().add(stopButton);
        getContentPane().add(drawButton);
        
        gbc.gridx = 0;
        gbc.gridy = 6;
        gbc.gridwidth = 4;
        gbl.setConstraints(progressBar, gbc);
        getContentPane().add(progressBar);
        gbc.gridy = 7;
        gbl.setConstraints(errorBar, gbc);
        getContentPane().add(errorBar);
        setStatus();

        progressBar.setStringPainted(true);
        errorBar.setStringPainted(true);
    }
    
    public void actionPerformed(ActionEvent e)
    {
        if (e.getActionCommand().equals("open"))
        {
            if (learnThread != null)
                return;
            
            fileChooser.removeChoosableFileFilter(nnFilter);
            fileChooser.addChoosableFileFilter(recFilter);
            if (fileChooser.showOpenDialog(this) != JFileChooser.APPROVE_OPTION)
                return;
            File target = fileChooser.getSelectedFile();
            try
            {
                loadRecord(target.toURL());
            }
            catch(MalformedURLException ex)
            {
                ex.printStackTrace();
            }
        }
        else if (e.getActionCommand().equals("open_network"))
        {
            if (learnThread != null)
                return;
            
            fileChooser.removeChoosableFileFilter(recFilter);
            fileChooser.addChoosableFileFilter(nnFilter);
            if (fileChooser.showOpenDialog(this) != JFileChooser.APPROVE_OPTION)
                return;
            File target = fileChooser.getSelectedFile();
            try
            {
                load(target);
            }
            catch(IOException exc)
            {
                exc.printStackTrace();
            }
        }
        else if (e.getActionCommand().equals("save_network"))
        {
            if (learnThread != null)
                return;

            fileChooser.removeChoosableFileFilter(recFilter);
            fileChooser.addChoosableFileFilter(nnFilter);
            if (fileChooser.showSaveDialog(this) != JFileChooser.APPROVE_OPTION)
                return;
            File target = fileChooser.getSelectedFile();
            try
            {
                save(target);
            }
            catch(IOException exc)
            {
                exc.printStackTrace();
            }
        }
        else if (e.getActionCommand().equals("reset"))
        {
            reset();
        }
        else if (e.getActionCommand().equals("learn"))
        {
            learn();
        }
        else if (e.getActionCommand().equals("stop"))
        {
            stopLearn();
        }
        else if (e.getActionCommand().equals("draw"))
        {
            if (org != null)
                draw();
        }
        else if (e.getActionCommand().equals("drawGraphCheck"))
        {
            if (org != null)
                draw();
        }
    }
    
    
    public void stateChanged(ChangeEvent e)
    {
        if (e.getSource() == drawGraphPageSpinner)
        {
            int pages = orgInputData.length / DEFAULT_GRAPH_WIDTH;
            try
            {
                drawGraphPage = Integer.valueOf(drawGraphPageSpinner.getValue().toString());
                if (drawGraphPage < 0)
                {
                    drawGraphPage = pages;
                    drawGraphPageSpinner.setValue(new Integer(pages));
                }
                else if (pages < drawGraphPage)
                {
                    drawGraphPage = 0;
                    drawGraphPageSpinner.setValue(new Integer(0));
                }
            }catch(NumberFormatException exc)
            {
                drawGraphPage = 0;
                drawGraphPageSpinner.setValue(new Integer(0));
            }
            draw();
        }
                
    }
    private void setStatus()
    {
        boolean lock = (learnThread != null);
        learnButton.setEnabled(!lock);
        stopButton.setEnabled(lock);
        drawButton.setEnabled(!lock);
        resetButton.setEnabled(!lock);
    }
     
    private void learn()
    {
        if (learnThread != null)
        {
            return;
        }
        int repeat;
        int threadNum;
        try
        {
            repeat = Integer.parseInt(repeatField.getText());
            if (repeat < 1)
                throw new NumberFormatException();
        }
        catch(NumberFormatException e)
        {
            repeatField.setText(""+DEFAULT_REPEAT);
            return;
        }
        try
        {
            threadNum = Integer.parseInt(threadNumField.getText());
            if (threadNum < 1)
                throw new NumberFormatException();
        }
        catch(NumberFormatException e)
        {
            threadNumField.setText("1");
            return;
        }
        double rate;
        try
        {
            rate = Double.parseDouble(rateField.getText());
            if (rate < 0 || rate > 1)
                throw new NumberFormatException();
        }
        catch(NumberFormatException e)
        {
            rateField.setText(""+DEFAULT_LEANINGRATE);
            return;
        }
        neuralNetwork.setLearningRate(rate);
        //neuralNetwork.setLearningWeight(1d);
        //neuralNetwork.setLearningWeight(new double[]{ 1, 1, 1, 1, 0.1, 0.1, 0.1, 0.1});
        learnThread = new LearnThread(repeat, threadNum);
        learnThread.setPriority(Thread.MIN_PRIORITY);
        learnThread.start();
        setStatus();
    }
    public void stopLearn()
    {
        if (learnThread == null)
        {
            return;
        }
        learnThread.stopLearning();
        try
        {
            learnThread.join();
        }
        catch(InterruptedException e)
        {
            e.printStackTrace();
        }
    }
    private void draw()
    {
        if (learnThread != null)
        {
            return;
        }
        draw(org);
        double error = 0d;
        for (int i=0;i<orgInputData.length;i++)
        {
            neuralNetwork.setInput(orgInputData[i]);
            neuralNetwork.feedForward();
            neuralNetwork.setDesiredOutput(orgDesiredData[i]);
            error += neuralNetwork.calculateError();
        }
        error /= orgInputData.length;
        errorBar.setString(""+error);
        
        repaint();
    }
    private void draw(BufferedImage img)
    {
        Graphics g = img.getGraphics();
        g.setColor(Color.WHITE);
        g.fillRect(0,0,img.getWidth(),img.getHeight());
        g.dispose();
        if (!drawGraphCheck.isSelected())
            return;
        
        if (drawGraphPage < 0 || orgInputData.length / DEFAULT_GRAPH_WIDTH < drawGraphPage)
        {
            drawGraphPage = 0;
            drawGraphPageSpinner.setValue(new Integer(0));
        }
        int offset = drawGraphPage * DEFAULT_GRAPH_WIDTH;
        for (int i=0;i<DEFAULT_GRAPH_WIDTH;i++)
        {
            int x = offset + i;
            if (x >= orgInputData.length)
                break;
            Color[] cs1,cs2;
            cs1 = doubleToRGB(orgDesiredData[x]);
            double[] ds = new double[outputNeuronNum];
            neuralNetwork.setInput(orgInputData[x]);
            neuralNetwork.feedForward();
            neuralNetwork.getOutput(ds);
            cs2 = doubleToRGB(ds);
            
            for (int j=0;j<cs1.length;j++)
            {
                img.setRGB(i,j*(BAR_WIDTH*2+1),Color.YELLOW.getRGB());
                for (int k=0;k<BAR_WIDTH;k++)
                {
                    img.setRGB(i,j*(BAR_WIDTH*2+1)+1+k,cs1[j].getRGB());
                    img.setRGB(i,j*(BAR_WIDTH*2+1)+1+BAR_WIDTH+k,cs2[j].getRGB());
                }
            }
        }
    }
    private void reset()
    {
        if (learnThread != null)
        {
            return;
        }
        int[] layout,it;
        it = stringToIntArray(layerLayoutField.getText());
        if (it == null)
        {
            layerLayoutField.setText(DEFAULT_LAYOUT);
            return;
        }
        layout = new int[it.length + 2];
        for (int i=0;i<it.length;i++)
        {
            layout[i+1] = it[i]; 
        }
        layout[0] = inputNeuronNum;
        layout[layout.length - 1] = outputNeuronNum;
        
        double rate;
        try
        {
            rate = Double.valueOf(rateField.getText());
            if (rate < 0 || rate > 1)
            {
                rateField.setText("" + DEFAULT_LEANINGRATE);
                return;
            }
        }
        catch (NumberFormatException e)
        {
            rateField.setText("" + DEFAULT_LEANINGRATE);
            return;
        }
        
        if (neuralNetwork != null)
            neuralNetwork.cleanUp();
        neuralNetwork = new NeuralNetwork();
        neuralNetwork.initialize(layout);
        neuralNetwork.setLearningRate(rate);
        neuralNetwork.setLinearOutput(false);
        //double[] learningWeight = new double[]{4,4,4,4,1,1,1,1};
        //neuralNetwork.setLearningWeight(learningWeight);
    }
    public void loadRecord(URL url)
    {
        if (learnThread != null)
        {
            stopLearn();
        }
        ByteArrayOutputStream rawData = new ByteArrayOutputStream(1024*1024);
        InputStream in = null;
        try
        {
            in = new GZIPInputStream(url.openStream());
            int i;
            while((i=in.read()) != -1)
            {
                rawData.write(i);
            }
            byte[] rd = rawData.toByteArray();
            DataInputStream din = new DataInputStream(new ByteArrayInputStream(rd));
            this.inputNeuronNum = din.readInt();
            this.outputNeuronNum = din.readInt();
            int dataNum = rd.length/((Integer.SIZE/8*2) + (inputNeuronNum+outputNeuronNum)*Double.SIZE/8);
            orgInputData = new double[dataNum][inputNeuronNum];
            orgDesiredData = new double[dataNum][outputNeuronNum];
            orgDesiredMin = new double[outputNeuronNum];
            orgDesiredMax = new double[outputNeuronNum];
            for (int j=0;j<outputNeuronNum;j++)
            {
                orgDesiredMin[j] = Double.NaN;
                orgDesiredMax[j] = Double.NaN;
            }
            for (int j=0;j<dataNum;j++)
            {
                if (inputNeuronNum != din.readInt())
                    throw new ArrayIndexOutOfBoundsException();
                for (int k=0;k<inputNeuronNum;k++)
                {
                    orgInputData[j][k] = din.readDouble();
                }
                if (outputNeuronNum != din.readInt())
                    throw new ArrayIndexOutOfBoundsException();
                for (int k=0;k<outputNeuronNum;k++)
                {
                    orgDesiredData[j][k] = din.readDouble();
                    if (Double.isNaN(orgDesiredMin[k]) || orgDesiredData[j][k] < orgDesiredMin[k])
                        orgDesiredMin[k] = orgDesiredData[j][k];
                    if (Double.isNaN(orgDesiredMax[k]) || orgDesiredData[j][k] > orgDesiredMax[k])
                        orgDesiredMax[k] = orgDesiredData[j][k];
                }
            }
//            System.out.println("DataNum :" + dataNum);
//            System.out.println("InputNodes :" + inputNum);
//            System.out.println("OutputNodes :" + outputNum);
//            for (int k=0;k<outputNum;k++)
//            {
//                System.out.println(orgDesiredMin[k] + ", " + orgDesiredMax[k]);
//            }
//            for (int j=0;j<dataNum;j++)
//            {
//                for (int k=0;k<orgDesiredData[j].length;k++)
//                {
//                    System.out.print(orgDesiredData[j][k] + ", ");
//                }
//                System.out.println();
//            }
        }
        catch(IOException exc)
        {
            exc.printStackTrace();
            JOptionPane.showMessageDialog(this, exc);
        }
        finally
        {
            try
            {
                if (in != null)
                {
                    in.close();
                }
            }
            catch(IOException e)
            {
            }
        }
        //org = new BufferedImage(orgInputData.length, aiRapper.getOutputNeuronNum()*(BAR_WIDTH*2+1), BufferedImage.TYPE_INT_RGB);
        org = new BufferedImage(DEFAULT_GRAPH_WIDTH, outputNeuronNum*(BAR_WIDTH*2+1), BufferedImage.TYPE_INT_RGB);
        orgGraph.setImage(org);
        reset();
        draw();
    }
    
    @Override
    public void start()
    {
        super.start();
    }
    @Override
    public void stop()
    {
        super.stop();
        stopLearn();
    }
    public static void main(String[] args)
    {
        AiLearningTool gt = new AiLearningTool(new File("./"));
        JFrame f = new JFrame();
        f.getContentPane().add(gt);
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        f.setSize(500,500);
//        try
//        {
//            gt.loadRecord(new File("/home/cattaka/.bakutan/ver3_test.rec").toURL());
//        }
//        catch(IOException e)
//        {
//            e.printStackTrace();
//        }
        f.setVisible(true);
    }
    public Color[] doubleToRGB(double[] ds)
    {
        Color[] cs = new Color[ds.length];
        int r,b;
        for (int i=0;i<ds.length;i++)
        {
            double d;
            if ((orgDesiredMax[i] - orgDesiredMin[i]) != 0)
                d = (ds[i] - orgDesiredMin[i])/(orgDesiredMax[i] - orgDesiredMin[i]);
            else
                d = ds[i];
            d = (d-0.5d)*2d;
            
            r = (int)(-d * 255d);
            r = (r<0) ? 0:r;
            r = (r>255) ? 255:r;
            b = (int)(d * 255d);
            b = (b<0) ? 0:b;
            b = (b>255) ? 255:b;
            cs[i] = new Color(r,0,b);
        }
        return cs;
    }
    
    class LearnThread extends Thread
    {
        int learnRepeat = 0;
        int threadNum = 0;
        boolean goFlag = false;
        
        public LearnThread(int learnRepeat,int threadNum)
        {
            this.learnRepeat = learnRepeat;
            this.threadNum = threadNum;
        }
        public void stopLearning()
        {
            goFlag = false;
        }
        
        @Override
        public void run()
        {
            super.run();
            FileWriter logWriter = null;
//            try
//            {
//                int[] layout = neuralNetwork.getLayerLayout();
//                File logfile = new File("learning" + layout[1] + "x" + (layout.length-2) + "_" + rateField.getText() +".log");
//                int num = 0;
//                while (logfile.exists())
//                {
//                    logfile = new File("learning" + layout[1] + "x" + (layout.length-2) + "_" + rateField.getText() + "_" + num +".log");
//                    num++;
//                }
//                logfile.createNewFile();
//                
//                logWriter = new FileWriter(logfile);
//                logWriter.write("layout, ");
//                for (int i=0;i<layout.length;i++)
//                {
//                    if (i == layout.length-1)
//                        logWriter.write(layout[i] + "\n");
//                    else
//                        logWriter.write(layout[i]+ ", ");
//                }
//                logWriter.write("rate, " + rateField.getText() + "\n");
//            }catch(IOException e)
//            {
//                e.printStackTrace();
//            }
            
            int num = orgInputData.length;
            long currenttime = System.currentTimeMillis();
            long starttime = currenttime;
            long lastDraw = currenttime;
                
            goFlag = true;
            progressBar.setMinimum(0);
            progressBar.setMaximum(learnRepeat);
            progressBar.setValue(0);
            progressBar.setString("0/" + learnRepeat);
            errorBar.setMinimum(0);
            errorBar.setMaximum(1000000);
            errorBar.setValue(0);
            int t;
            for (t = 0;t<learnRepeat && goFlag;t++)
            {
                if (currenttime - lastDraw > 1000)
                {
                    lastDraw = currenttime;
                    orgGraph.setImage(null);
                    draw(org);
                    orgGraph.setImage(org);
                    orgGraph.repaint();
                }
                
                //System.out.println("repeat " + t);
                double error = 0d;
                if (threadNum == 1)
                {
                    for (int i = 0;i<num;i++)
                    {
                        //int p = (int)(orgInputData.length * Math.random());
                        int p = i;
                        neuralNetwork.setInput(orgInputData[p]);
                        neuralNetwork.setDesiredOutput(orgDesiredData[p]);
                        neuralNetwork.feedForward();
                        neuralNetwork.backPropagate();
                        error += neuralNetwork.calculateError();
                    }
                    error /= num;
                }
                else
                {
                    error = neuralNetwork.startLearnWithMultiThread(threadNum, orgInputData, orgDesiredData);
                }

                
                int k = t + 1;
                progressBar.setValue(k);
                progressBar.setString("" + k + "/" + learnRepeat);
                errorBar.setString(""+error);
                errorBar.setValue((int)(error *1000000));
                
                try
                {
                    if (logWriter != null)
                        logWriter.write("" + t + ", " + Double.toString(error) + "\n");
                }
                catch(IOException e)
                {
                    e.printStackTrace();
                }
                currenttime = System.currentTimeMillis();
            }
            //currenttime = System.currentTimeMillis();
            double time = (double)(currenttime - starttime) / 1000d;
            System.out.println("repeat " + t + ", time " + time + "sec");
            System.out.println( (time/t) + "sec/repeat");
            
            try
            {
                if (logWriter != null)
                    logWriter.close();
            }
            catch(IOException e)
            {
                e.printStackTrace();
            }
            
            learnThread = null;
            setStatus();
        }
    }
    public void load(File target) throws IOException
    {
        FileInputStream in = new FileInputStream(target);
        neuralNetwork = NeuralNetwork.loadFromStream(in);
        in.close();
        int[] layout = neuralNetwork.getLayerLayout();
//        nodeNumField.setText("" + layout[1]);
//        layerNumField.setText("" + (layout.length - 2));
        if (layout.length > 2)
        {
            int[] it = new int[layout.length - 2];
            for (int i=0;i<it.length;i++)
            {
                it[i] = layout[i+1];
            }
            layerLayoutField.setText(intArrayToString(it));
        }
        draw();
    }
    public void save(File target) throws IOException
    {
        FileOutputStream out = new FileOutputStream(target);
        NeuralNetwork.dumpToStream(out, neuralNetwork);
        out.close();
    }
    public int[] stringToIntArray(String args)
    {
        String[] st = args.split("[,]");
        if (st.length == 0)
            return null;
        int[] it = new int[st.length];
        for (int i=0;i<it.length;i++)
        {
            try
            {
                it[i] = Integer.parseInt(st[i].trim());
            }
            catch(NumberFormatException e)
            {
                return null;
            }
        }
        return it;
    }
    public String intArrayToString(int[] args)
    {
        StringBuffer sb = new StringBuffer(100);
        for(int i=0;i<args.length;i++)
        {
            sb.append(args[i]);
            if (i < args.length-1)
            {
                sb.append(", ");
            }
        }
        return sb.toString();
    }
}

class NNFilter extends FileFilter
{
    @Override
    public boolean accept(File f)
    {
        if (f.isDirectory())
            return true;
        return f.getName().matches(".*[.][nN][nN]");
    }

    @Override
    public String getDescription()
    {
        return "NeuralNetwork file";
    }
}
class RecFilter extends FileFilter
{
    @Override
    public boolean accept(File f)
    {
        if (f.isDirectory())
            return true;
        return f.getName().matches(".*[.][rR][eE][cC]");
    }

    @Override
    public String getDescription()
    {
        return "Record file";
    }
}
