package bakutan.client;
import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import bakutan.common.DataManager;
import bakutan.common.LoginInfo;

public class InputLoginInfoDialog extends JDialog implements ActionListener
{
    private JTextField nicknamef;
    private JTextField usernamef;
	private JPasswordField passwordf;
    private JPasswordField confirmf;
    private JRadioButton guest = new JRadioButton("guest login");
    private JRadioButton login = new JRadioButton("login");
    private JRadioButton newAcount = new JRadioButton("new acount");
    JLabel usernamel = new JLabel("User name");
    JLabel nicknamel = new JLabel("Nick name");
    JLabel passwordl = new JLabel("Password");
    JLabel confirml = new JLabel("Confirm password");
    private boolean confirm = false;
    
	public InputLoginInfoDialog()
	{
		setTitle("Input Nickname");
		setSize(300,300);
		initialize();
	}

	public void initialize()
	{
        nicknamef = new JTextField(DataManager.NICKNAME_LENGTH);
        usernamef = new JTextField(DataManager.USERNAME_LENGTH);
        passwordf = new JPasswordField(DataManager.PASSWORD_LENGTH);
        confirmf = new JPasswordField(DataManager.PASSWORD_LENGTH);
        
		JButton bok = new JButton("OK");
        JButton bcancel = new JButton("Cancel");
        
        ButtonGroup group = new ButtonGroup();
        group.add(guest);
        group.add(login);
        group.add(newAcount);
        
        GridBagLayout gbl = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.weighty=0;

		Dimension d;
		d = nicknamef.getPreferredSize(); d.width = 0;
        nicknamef.setPreferredSize(d);
		d = usernamef.getPreferredSize(); d.width = 0;
		usernamef.setPreferredSize(d);
		d = passwordf.getPreferredSize(); d.width = 0;
		passwordf.setPreferredSize(d);

		gbc.gridx=0;
        gbc.gridy=0;
        gbl.setConstraints(nicknamel,gbc);
        gbc.gridy=1;
		gbl.setConstraints(usernamel,gbc);
        gbc.gridy=2;
		gbl.setConstraints(passwordl,gbc);
        gbc.gridy=3;
        gbl.setConstraints(confirml,gbc);

		gbc.weightx=1;
		gbc.gridx=1;
        gbc.gridy=0;
        gbl.setConstraints(nicknamef,gbc);
		gbc.gridy=1;
        gbl.setConstraints(usernamef,gbc);
        gbc.gridy=2;
        gbl.setConstraints(passwordf,gbc);
        gbc.gridy=3;
        gbl.setConstraints(confirmf,gbc);
        gbc.gridy=4;
        gbl.setConstraints(guest,gbc);
        gbc.gridy=5;
        gbl.setConstraints(login,gbc);
        gbc.gridy=6;
        gbl.setConstraints(newAcount,gbc);

		gbc.weightx=0;
		gbc.fill = GridBagConstraints.NONE;
		gbc.gridx=0;
        gbc.gridy=7;
		gbc.gridwidth=2;
		gbl.setConstraints(bok,gbc);
        gbc.gridy=8;
        gbl.setConstraints(bcancel,gbc);

		getContentPane().setLayout(gbl);
		getContentPane().add(usernamel);
		getContentPane().add(usernamef);
		getContentPane().add(passwordl);
		getContentPane().add(passwordf);
        getContentPane().add(nicknamel);
        getContentPane().add(nicknamef);
        getContentPane().add(confirml);
        getContentPane().add(confirmf);
		getContentPane().add(bok);
        getContentPane().add(bcancel);
		getContentPane().add(guest);
        getContentPane().add(login);
        getContentPane().add(newAcount);

        bok.setActionCommand("ok");
        bcancel.setActionCommand("cancel");
		bok.addActionListener(this);
		bcancel.addActionListener(this);
        
		guest.addActionListener(this);
		login.addActionListener(this);
        newAcount.addActionListener(this);
        guest.setSelected(true);
        update();
    }
	
	public void setUsername(String arg)
	{
		usernamef.setText(arg);
	}
	public String getUsername()
	{
		return usernamef.getText();
	}
	public String getPassword()
	{
		return new String(passwordf.getPassword());
	}
    public void setNickname(String arg)
    {
        nicknamef.setText(arg);
    }
    public String getNickname()
    {
        return nicknamef.getText();
    }
	public void setGuest(boolean v)
	{
		guest.setSelected(v);
		passwordf.setEditable(!v);
	}
	private void update()
    {
	    if(guest.isSelected())
        {
            nicknamef.setEnabled(true);
	        usernamef.setEnabled(false);
            passwordf.setEnabled(false);
            confirmf.setEnabled(false);
            nicknamel.setEnabled(true);
            usernamel.setEnabled(false);
            passwordl.setEnabled(false);
            confirml.setEnabled(false);
        }
        else if(newAcount.isSelected())
        {
            nicknamef.setEnabled(true);
            usernamef.setEnabled(true);
            passwordf.setEnabled(true);
            confirmf.setEnabled(true);
            nicknamel.setEnabled(true);
            usernamel.setEnabled(true);
            passwordl.setEnabled(true);
            confirml.setEnabled(true);
        }
        else
        {
            nicknamef.setEnabled(false);
            usernamef.setEnabled(true);
            passwordf.setEnabled(true);
            confirmf.setEnabled(false);
            nicknamel.setEnabled(false);
            usernamel.setEnabled(true);
            passwordl.setEnabled(true);
            confirml.setEnabled(false);
        }
    }
    
	public void actionPerformed(ActionEvent e)
	{
		if (e.getActionCommand().equals("ok"))
		{
            boolean f = true;
            if (usernamef.getText().length() > DataManager.USERNAME_LENGTH)
            {
                f = false;
                usernamef.setText(usernamef.getText().substring(0,DataManager.USERNAME_LENGTH));
            }
            if (nicknamef.getText().length() > DataManager.NICKNAME_LENGTH)
            {
                f = false;
                nicknamef.setText(nicknamef.getText().substring(0,DataManager.NICKNAME_LENGTH));
            }
            if (passwordf.getPassword().length > DataManager.PASSWORD_LENGTH)
            {
                f = false;
                passwordf.setText("");
            }
            if (newAcount.isSelected())
            {
                char[] c1 = passwordf.getPassword();
                char[] c2 = confirmf.getPassword();
                if (c1.length != c2.length)
                {
                    f = false;
                }
                else
                {
                    for (int i=0;i<c1.length;i++)
                    {
                        if (c1[i] != c2[i])
                        {
                            f = false;
                            break;
                        }
                    }
                }
                if (!f)
                {
                    confirmf.setText("");
                }
            }
            if (f)
            {
                confirm = true;
                setVisible(false);
            }
		}
        else if (e.getActionCommand().equals("cancel"))
        {
            confirm = false;
            setVisible(false);
        }
        else
        {
            update();
        }
	}

    public LoginInfo showDialog()
    {
        setModal(true);
        setVisible(true);
        if (!confirm)
            return null;
        LoginInfo li = new LoginInfo(getUsername(),getNickname(),getPassword(), -1);
        if (guest.isSelected())
        {
            li.setMode(LoginInfo.MODE_GUEST);
        }
        else if (newAcount.isSelected())
        {
            li.setMode(LoginInfo.MODE_NEWACOUNT);
        }
        else    
        {
            li.setMode(LoginInfo.MODE_LOGIN);
        }
        
        return li;
    }
	public static void main(String[] args)
	{
		InputLoginInfoDialog d = new InputLoginInfoDialog();
        System.out.println(d.showDialog());
        System.exit(0);
	}
}
