/*
 * 作成日: 2007/01/13
 */
package bakutan.client;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import bakutan.common.BUserInterface;
import static bakutan.client.KeyConfig.*;
import static bakutan.client.BakutanKeyConfig.*;

public class KeyConfigPanel extends JPanel implements ActionListener, KeyListener, MouseListener, ItemListener
{
    public static final int NUM = 4;
    
    private BUserInterface userinterface;
    private KeyConfig keyConfig;
    private JTextField fieldUp = new JTextField(NUM);
    private JTextField fieldDown = new JTextField(NUM);
    private JTextField fieldLeft = new JTextField(NUM);
    private JTextField fieldRight = new JTextField(NUM);
    private JTextField fieldWeaponNext = new JTextField(NUM);
    private JTextField fieldWeaponPrev = new JTextField(NUM);
    private JTextField fieldAttack = new JTextField(NUM);
    private JTextField fieldSelectAction1 = new JTextField(NUM);
    private JTextField fieldSelectAction2 = new JTextField(NUM);
    private JTextField fieldSelectAction3 = new JTextField(NUM);
    private JTextField fieldSelectAction4 = new JTextField(NUM);
    private JTextField fieldSelectAction5 = new JTextField(NUM);
    private JTextField fieldSelectAction6 = new JTextField(NUM);
    private JTextField fieldSelectAction7 = new JTextField(NUM);
    private JTextField fieldSelectAction8 = new JTextField(NUM);
    private JTextField fieldSelectAction9 = new JTextField(NUM);
    private JTextField fieldAction1 = new JTextField(NUM);
    private JTextField fieldAction2 = new JTextField(NUM);
    private JTextField fieldAction3 = new JTextField(NUM);
    private JTextField fieldAction4 = new JTextField(NUM);
    private JTextField fieldAction5 = new JTextField(NUM);
    private JTextField fieldAction6 = new JTextField(NUM);
    private JTextField fieldAction7 = new JTextField(NUM);
    private JTextField fieldAction8 = new JTextField(NUM);
    private JTextField fieldAction9 = new JTextField(NUM);
    private JTextField[] fields = new JTextField[25];

    private JComboBox comboMouseButton1 = new JComboBox();
    private JComboBox comboMouseButton2 = new JComboBox();
    private JComboBox comboMouseButton3 = new JComboBox();
    private JComboBox[] combos = new JComboBox[3];
    private int[] actions = new int[26];
    
    public KeyConfigPanel(BUserInterface userInterface)
    {
        super();
        this.userinterface = userInterface;
        this.keyConfig = new KeyConfig();
        BakutanKeyConfig.makeDefault(this.keyConfig);
        makeLayout();
        updateField();
    }
    private void makeLayout()
    {
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.fill = GridBagConstraints.HORIZONTAL;
        JLabel labelUp = new JLabel(userinterface.translate(getActionName(ACTION_UP)));
        JLabel labelDown = new JLabel(userinterface.translate(getActionName(ACTION_DOWN)));
        JLabel labelLeft = new JLabel(userinterface.translate(getActionName(ACTION_LEFT)));
        JLabel labelRight = new JLabel(userinterface.translate(getActionName(ACTION_RIGHT)));
        JLabel labelWeaponNext = new JLabel(userinterface.translate(getActionName(ACTION_WEAPON_NEXT)));
        JLabel labelWeaponPrev = new JLabel(userinterface.translate(getActionName(ACTION_WEAPON_PREV)));
        JLabel labelAttack = new JLabel(userinterface.translate(getActionName(ACTION_ATTACK)));
        JLabel labelSelectAction1 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_1)));
        JLabel labelSelectAction2 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_2)));
        JLabel labelSelectAction3 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_3)));
        JLabel labelSelectAction4 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_4)));
        JLabel labelSelectAction5 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_5)));
        JLabel labelSelectAction6 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_6)));
        JLabel labelSelectAction7 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_7)));
        JLabel labelSelectAction8 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_8)));
        JLabel labelSelectAction9 = new JLabel(userinterface.translate(getActionName(ACTION_SELECT_ACTION_9)));
        JLabel labelAction1 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_1)));
        JLabel labelAction2 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_2)));
        JLabel labelAction3 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_3)));
        JLabel labelAction4 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_4)));
        JLabel labelAction5 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_5)));
        JLabel labelAction6 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_6)));
        JLabel labelAction7 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_7)));
        JLabel labelAction8 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_8)));
        JLabel labelAction9 = new JLabel(userinterface.translate(getActionName(ACTION_ACTION_9)));

        JLabel labelMouseButton1 = new JLabel(userinterface.translate("mouse_button_1"));
        JLabel labelMouseButton2 = new JLabel(userinterface.translate("mouse_button_2"));
        JLabel labelMouseButton3 = new JLabel(userinterface.translate("mouse_button_3"));
        
        JButton buttonDefault = new JButton(userinterface.translate("default"));
        buttonDefault.setActionCommand("default");
        buttonDefault.addActionListener(this);
        
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbl.setConstraints(labelUp,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelDown,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelLeft,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelRight,gbc);
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbl.setConstraints(fieldUp,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldDown,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldLeft,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldRight,gbc);
        
        gbc.gridx = 2;
        gbc.gridy = 0;
        gbl.setConstraints(labelWeaponNext,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelWeaponPrev,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAttack,gbc);
        gbc.gridx = 3;
        gbc.gridy = 0;
        gbl.setConstraints(fieldWeaponNext,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldWeaponPrev,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAttack,gbc);
        
        
        gbc.gridx = 0;
        gbc.gridy = 4;
        gbl.setConstraints(labelSelectAction1,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction2,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction3,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction4,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction5,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction6,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction7,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction8,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelSelectAction9,gbc);
        gbc.gridx = 1;
        gbc.gridy = 4;
        gbl.setConstraints(fieldSelectAction1,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction2,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction3,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction4,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction5,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction6,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction7,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction8,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldSelectAction9,gbc);
        
        gbc.gridx = 2;
        gbc.gridy = 4;
        gbl.setConstraints(labelAction1,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction2,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction3,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction4,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction5,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction6,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction7,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction8,gbc);
        gbc.gridy++;
        gbl.setConstraints(labelAction9,gbc);
        gbc.gridx = 3;
        gbc.gridy = 4;
        gbl.setConstraints(fieldAction1,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction2,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction3,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction4,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction5,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction6,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction7,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction8,gbc);
        gbc.gridy++;
        gbl.setConstraints(fieldAction9,gbc);

        gbc.gridwidth = 2;
        gbc.gridx = 0;
        gbc.gridy = 13;
        gbl.setConstraints(labelMouseButton1, gbc);
        gbc.gridy++;
        gbl.setConstraints(labelMouseButton2, gbc);
        gbc.gridy++;
        gbl.setConstraints(labelMouseButton3, gbc);
        gbc.gridx = 2;
        gbc.gridy = 13;
        gbl.setConstraints(comboMouseButton1, gbc);
        gbc.gridy++;
        gbl.setConstraints(comboMouseButton2, gbc);
        gbc.gridy++;
        gbl.setConstraints(comboMouseButton3, gbc);
        
        gbc.gridx = 0;
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridwidth = 4;
        gbc.gridy++;
        gbl.setConstraints(buttonDefault,gbc);
        

        setLayout(gbl);
        add(labelUp);
        add(labelDown);
        add(labelLeft);
        add(labelRight);
        add(labelWeaponNext);
        add(labelWeaponPrev);
        add(labelAttack);
        add(labelSelectAction1);
        add(labelSelectAction2);
        add(labelSelectAction3);
        add(labelSelectAction4);
        add(labelSelectAction5);
        add(labelSelectAction6);
        add(labelSelectAction7);
        add(labelSelectAction8);
        add(labelSelectAction9);
        add(labelAction1);
        add(labelAction2);
        add(labelAction3);
        add(labelAction4);
        add(labelAction5);
        add(labelAction6);
        add(labelAction7);
        add(labelAction8);
        add(labelAction9);
        add(fieldUp);
        add(fieldDown);
        add(fieldLeft);
        add(fieldRight);
        add(fieldWeaponNext);
        add(fieldWeaponPrev);
        add(fieldAttack);
        add(fieldSelectAction1);
        add(fieldSelectAction2);
        add(fieldSelectAction3);
        add(fieldSelectAction4);
        add(fieldSelectAction5);
        add(fieldSelectAction6);
        add(fieldSelectAction7);
        add(fieldSelectAction8);
        add(fieldSelectAction9);
        add(fieldAction1);
        add(fieldAction2);
        add(fieldAction3);
        add(fieldAction4);
        add(fieldAction5);
        add(fieldAction6);
        add(fieldAction7);
        add(fieldAction8);
        add(fieldAction9);
        add(labelMouseButton1);
        add(labelMouseButton2);
        add(labelMouseButton3);
        add(comboMouseButton1);
        add(comboMouseButton2);
        add(comboMouseButton3);
        add(buttonDefault);
        
        int i=0;
        fields[i++] = fieldUp;
        fields[i++] = fieldDown;
        fields[i++] = fieldLeft;
        fields[i++] = fieldRight;
        fields[i++] = fieldWeaponNext;
        fields[i++] = fieldWeaponPrev;
        fields[i++] = fieldAttack;
        fields[i++] = fieldSelectAction1;
        fields[i++] = fieldSelectAction2;
        fields[i++] = fieldSelectAction3;
        fields[i++] = fieldSelectAction4;
        fields[i++] = fieldSelectAction5;
        fields[i++] = fieldSelectAction6;
        fields[i++] = fieldSelectAction7;
        fields[i++] = fieldSelectAction8;
        fields[i++] = fieldSelectAction9;
        fields[i++] = fieldAction1;
        fields[i++] = fieldAction2;
        fields[i++] = fieldAction3;
        fields[i++] = fieldAction4;
        fields[i++] = fieldAction5;
        fields[i++] = fieldAction6;
        fields[i++] = fieldAction7;
        fields[i++] = fieldAction8;
        fields[i++] = fieldAction9;

        i = 0;
        combos[i++] = comboMouseButton1;
        combos[i++] = comboMouseButton2;
        combos[i++] = comboMouseButton3;

        i=0;
        actions[i++] = ACTION_UP;
        actions[i++] = ACTION_DOWN;
        actions[i++] = ACTION_LEFT;
        actions[i++] = ACTION_RIGHT;
        actions[i++] = ACTION_WEAPON_NEXT;
        actions[i++] = ACTION_WEAPON_PREV;
        actions[i++] = ACTION_ATTACK;
        actions[i++] = ACTION_SELECT_ACTION_1;
        actions[i++] = ACTION_SELECT_ACTION_2;
        actions[i++] = ACTION_SELECT_ACTION_3;
        actions[i++] = ACTION_SELECT_ACTION_4;
        actions[i++] = ACTION_SELECT_ACTION_5;
        actions[i++] = ACTION_SELECT_ACTION_6;
        actions[i++] = ACTION_SELECT_ACTION_7;
        actions[i++] = ACTION_SELECT_ACTION_8;
        actions[i++] = ACTION_SELECT_ACTION_9;
        actions[i++] = ACTION_ACTION_1;
        actions[i++] = ACTION_ACTION_2;
        actions[i++] = ACTION_ACTION_3;
        actions[i++] = ACTION_ACTION_4;
        actions[i++] = ACTION_ACTION_5;
        actions[i++] = ACTION_ACTION_6;
        actions[i++] = ACTION_ACTION_7;
        actions[i++] = ACTION_ACTION_8;
        actions[i++] = ACTION_ACTION_9;
        actions[i++] = ACTION_MOUSE_MOVE;
        
        for (i=0;i<fields.length;i++)
        {
            fields[i].setEditable(false);
            fields[i].addKeyListener(this);
            fields[i].addMouseListener(this);
        }
        
        for (i=0;i<actions.length;i++)
        {
            String actionName = getActionName(actions[i]);
            comboMouseButton1.addItem(userinterface.translate(actionName));
            comboMouseButton2.addItem(userinterface.translate(actionName));
            comboMouseButton3.addItem(userinterface.translate(actionName));
        }
        comboMouseButton1.setSelectedIndex(25);
        comboMouseButton2.setSelectedIndex(6);
        comboMouseButton3.setSelectedIndex(20);
        comboMouseButton1.addItemListener(this);
        comboMouseButton2.addItemListener(this);
        comboMouseButton3.addItemListener(this);
    }
    private void updateField()
    {
        for (int i=0;i<fields.length;i++)
        {
            updateField(fields[i], keyConfig.getKeyCode(actions[i]));
        }
        for (int i=0;i<actions.length;i++)
        {
            for (int j=0;j<keyConfig.getMouseActionNum();j++)
            {
                if (keyConfig.getMouseAction(j) == actions[i])
                {
                    combos[j].setSelectedIndex(i);
                }
            }
        }
    }
    private void updateField(JTextField target, int keyCode)
    {
        if (keyCode == -1)
            target.setText("");
        else
            target.setText(KeyEvent.getKeyText(keyCode));
    }
    
    public KeyConfig getKeyConfig()
    {
        return keyConfig;
    }
    public void setKeyConfig(KeyConfig keyConfig)
    {
        this.keyConfig.set(keyConfig);
        updateField();
    }
    public static void main(String[] args)
    {
        ServerInfoApplet sia = new ServerInfoApplet();
        KeyConfigPanel panel = new KeyConfigPanel(sia);
        JFrame frame = new JFrame();
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(500,300);
        frame.getContentPane().add(panel);
        frame.setVisible(true);
    }
    public void actionPerformed(ActionEvent e)
    {
        if (e.getActionCommand().equals("default"))
        {
            BakutanKeyConfig.makeDefault(this.keyConfig);
            updateField();
        }
    }
    public void keyPressed(KeyEvent e)
    {
        if (e.getSource() instanceof JTextField)
        {
            int t = -1;
            for (int i=0;i<fields.length;i++)
            {
                if (fields[i] == e.getSource())
                {
                    t = i;
                    break;
                }
            }
            if (t != -1)
            {
                keyConfig.putKeyToAction(e.getKeyCode(), actions[t]);
                updateField();
                //updateField(fields[t],e.getKeyCode());
            }
        }
    }
    public void keyReleased(KeyEvent e)
    {
    }
    public void keyTyped(KeyEvent e)
    {
    }
    public void mouseClicked(MouseEvent e)
    {
        if (e.getSource() instanceof JTextField)
        {
            int t = -1;
            for (int i=0;i<fields.length;i++)
            {
                if (fields[i] == e.getSource())
                {
                    t = i;
                    break;
                }
            }
            if (t != -1)
            {
                keyConfig.removeAction(actions[t]);
                updateField();
            }
        }
    }
    public void mouseEntered(MouseEvent e)
    {
    }
    public void mouseExited(MouseEvent e)
    {
    }
    public void mousePressed(MouseEvent e)
    {
    }
    public void mouseReleased(MouseEvent e)
    {
    }
    public void itemStateChanged(ItemEvent e)
    {
        if (e.getSource() instanceof JComboBox && e.getStateChange() == ItemEvent.SELECTED)
        {
            int t = -1;
            for (int i=0;i<combos.length;i++)
            {
                if (combos[i] == e.getSource())
                {
                    t = i;
                    break;
                }
            }
            if (t != -1)
            {
                int selected = combos[t].getSelectedIndex();
                int action = actions[selected];
                keyConfig.setMouseAction(t, action);
            }
        }
    }
    
}
