/*
 * 作成日: 2007/01/26
 */
package bakutan.common;

import java.awt.GridLayout;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import bakutan.common.util.BAudio;
import bakutan.common.util.LanguageTranslator;
import bakutan.common.util.NullBAudio;

public class BUserInterfacePanel extends JPanel implements BUserInterface
{
    public static final int MESSAGE_ROWS = 30;

    private LanguageTranslator languageTranslator;
    private BAudio baudio = new NullBAudio();
    private JTextArea messageArea;
    private int messageAreaRows = 0;
    private File workDir = null;
    private SimpleDateFormat dateFormat = new SimpleDateFormat();
    private boolean outputDate = false;
    
    public BUserInterfacePanel()
    {
        super();
        this.languageTranslator = SimpleUserInterface.createLanguageTranslator();
        makeLayout();
    }
    public BUserInterfacePanel(File workDir)
    {
        this();
        this.workDir = workDir;
    }
    private void makeLayout()
    {
        messageArea = new JTextArea();
        messageArea.setEditable(false);
        setLayout(new GridLayout());
        JScrollPane messagePane = new JScrollPane(messageArea);
        add(messagePane);
    }
    
    public BAudio getBAudio()
    {
        return baudio;
    }

    public File getWorkDir()
    {
        return workDir;
    }

    public void outputMessage(String message)
    {
        int r = 1;
        int index = 0;
        while ((index = message.indexOf('\n', index)) != -1)
        {
            r++;
        }
        messageAreaRows += r;
        if (outputDate)
            messageArea.append(dateFormat.format(new Date()) + " : " + message + "\n");
        else
            messageArea.append(message + "\n");
            
        index = 0;
        if (messageAreaRows > MESSAGE_ROWS)
        {
            for (int i=0;i<=messageAreaRows - MESSAGE_ROWS;i++)
            {
                index = messageArea.getText().indexOf('\n', index);
            }
            messageArea.replaceRange("", 0, index+1);
            messageAreaRows = 5;
        }
        messageArea.setCaretPosition(messageArea.getText().length());
    }

    public String translate(String key, String[] opt)
    {
        return languageTranslator.translate(key, opt);
    }

    public String translate(String key)
    {
        return languageTranslator.translate(key, new String[0]);
    }
    public boolean isOutputDate()
    {
        return outputDate;
    }
    public void setOutputDate(boolean outputDate)
    {
        this.outputDate = outputDate;
    }
}
