/*
 * 作成日: 2007/01/07
 */
package bakutan.common;

import java.util.Timer;
import java.util.TimerTask;

public class ClockTimer
{
    private Timer timer;
    private int interval;
    private boolean flag = true;
    private ClockTask task;
    
    public ClockTimer(int interval)
    {
        super();
        this.interval = interval;
        timer = new Timer("ClockTimer Thread");
        setInterval(interval);
    }
    private void flip()
    {
        synchronized (this)
        {
            this.flag = true;
            this.notify();
        }
    }
    public void pass()
    {
        synchronized (this)
        {
            while (!flag)
            {
                try
                {
                    this.wait();
                }
                catch(InterruptedException e)
                {
                }
            }
            flag = false;
            return;
        }
    }

    public int getInterval()
    {
        return interval;
    }
    public void setInterval(int interval)
    {
        if (task != null)
            task.cancel();
        this.interval = interval;
        System.out.println(interval);
        task = new ClockTask();
        timer.schedule(task, 0, interval);
    }
    public void stop()
    {
        timer.cancel();
        synchronized (this)
        {
            notifyAll();
        }
    }
    class ClockTask extends TimerTask
    {
//        long currenttime = System.currentTimeMillis();
        public ClockTask()
        {
        }
        
        @Override
        public void run()
        {
//            long t = System.currentTimeMillis();
//            System.out.println(t - currenttime);
//            currenttime = t;
            flip();
        }
    }
}

