/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/02/07
 */
package bakutan.common;

import bakutan.common.Body;
import bakutan.common.math.BVector2f;

/**
 * @author cattaka
 */
public interface EventHandler
{
	public EventThread getEventThread();
	public void multiAdd(long currentTime, long generationTime, Body[] targets);
    public void add(long currentTime, long generationTime, Body target);
	public void delete(long currentTime, long generationTime, Body target);
	public void armor(long currentTime, long generationTime, Body target, Body from, byte type, int armor);
	public void move(long currentTime, long generationTime, Body target, BVector2f position, BVector2f velocity, BVector2f direction);
	public void setPosition(long currentTime, long generationTime, Body target, BVector2f position);
	public void action(long currentTime, long generationTime, Body target, BVector2f position, byte action);
    public void smallAction(long currentTime, long generationTime, Body target, byte action);
	public void state(long currentTime, long generationTime, Body target, byte type, int state);
	public void option(long currentTime, long generationTime, Body target, byte type, int option);
	public void sound(long currentTime, long generationTime, Body target, byte type);
    public void sound(long currentTime, long generationTime, BVector2f pos, byte type);
	public void sound(long currentTime, long generationTime, byte type);
	public void message(long currentTime, long generationTime, Body target, byte type, String message);
	public void message(long currentTime, long generationTime,  byte type, String message);
	public void score(long currentTime, long generationTime, Body[] targets, int[] scores);
    public void scoreChange(long currentTime, long generationTime, Body from, Body[] targets, int[] scores);
	public void stageMessage(long currentTime, long generationTime, byte type, String message);
    public void recheckIntersect(long currentTime, long generationTime, Body target);
	//public void stageAction(long currentTime, long generationTime, int action);
}
