/*
 * 鐃緒申.鐃緒申: 2007/01/17
 */
package bakutan.common;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.zip.GZIPOutputStream;

import bakutan.common.ai.AIInterface;
import bakutan.common.ai.AIOutput;
import bakutan.common.ai.BStageInfoForAI;
import bakutan.common.ai.BodyInfoForAI;
import bakutan.common.event.BodyActionEvent;
import bakutan.common.event.BodyActionLockEnergyEvent;
import bakutan.common.event.BodyAddEvent;
import bakutan.common.event.BodyArmorEvent;
import bakutan.common.event.BodyClientIDEvent;
import bakutan.common.event.BodyCommandEvent;
import bakutan.common.event.BodyDeleteEvent;
import bakutan.common.event.BodyEvent;
import bakutan.common.event.BodyKnock;
import bakutan.common.event.BodyMessageEvent;
import bakutan.common.event.BodyMoveEvent;
import bakutan.common.event.BodyMultiAddEvent;
import bakutan.common.event.BodyOptionEvent;
import bakutan.common.event.BodyPushEvent;
import bakutan.common.event.BodyScoreEvent;
import bakutan.common.event.BodySetPotisionEvent;
import bakutan.common.event.BodySmallActionEvent;
import bakutan.common.event.BodySoundEvent;
import bakutan.common.event.BodyStageMessageEvent;
import bakutan.common.event.BodyStateEvent;
import bakutan.common.event.DisconnectEvent;
import bakutan.common.event.GameRestartEvent;
import bakutan.common.event.GameSetEvent;
import bakutan.common.math.BMath;
import bakutan.common.math.BVector2f;
import bakutan.common.util.BakutanClock;
import bakutan.common.util.DataFlusher;
import bakutan.common.util.PacketManager;

public class GameThread extends Thread
{
    protected BUserInterface userinterface;
    private GameOption gameOption;
    private String message;
    private List<ClientStageEvent> stageEvents = new LinkedList<ClientStageEvent>();
    private DataFlusher dataFlusher;
    private DataManager dataManager;
    private boolean restart = false;
    private boolean goflag = false;
    private float energy = 0f;
    //for calc rag
    private int rag = 0;
    private int knockTimeRead = 0;
    private int knockTimeWrite = 0;
    private long[] knockTime = new long[100];
    
    //common
    protected boolean stopFlag = false;
    protected boolean viewMode = false;
    protected BStage bstage;
    protected long currenttime;
    protected long timelimit;
    protected long lastUpdateTime;
    //protected long lastVelocityUpdateTime;
    protected ClientBody myBody = null;
    protected ClientBody myBodyGhost = null;
    protected int redout = 0;

    public GameThread(DataManager dataManager, BUserInterface userinterface, GameOption gameThreadOption)
    {
        super("Draw Thread");
        this.dataManager = dataManager;
        this.userinterface = userinterface;
        this.gameOption = gameThreadOption;
    }
    public synchronized void startDrawThread(BStage bstage)
    {
        if (bstage == null)
            throw new NullPointerException();
        
        if (isAlive())
            throw new RuntimeException();

        this.bstage = bstage;
        viewMode = true;
        dataFlusher = null;

        //setPriority(Thread.MIN_PRIORITY + 1);
        start();
    }
    public synchronized void startDrawThread(BStage bstage, DataFlusher out)
    {
        if (bstage == null || out == null)
            throw new NullPointerException();

        if (isAlive())
            throw new RuntimeException();
        
        this.bstage = bstage;
        viewMode = false;
        dataFlusher = out;
        
        //setPriority(Thread.MIN_PRIORITY + 1);
        start();
    }
    public void stopDrawThread()
    {
        this.restart = false;
        goflag = false;
        try
        {
            join();
        }catch(InterruptedException e)
        {
        }
    }
    protected void proceedUserInput(boolean[] actions, BVector2f actionTargetPoint, BVector2f inputVelocity)
    {
    }
    protected void proceedPrepare()
    {
    }
    protected void proceedDraw()
    {
    }
    protected void proceedDispose()
    {
    }
    protected void proceedActionForClient(BodyEvent event, Body body, long currenttime)
    {
    }
    protected void proceedShowMarker()
    {
    }
    protected void proceedSoundEvent(BodySoundEvent bse, Body target, int rag)
    {
    }
    protected void proceedBodyAdd(Body body)
    {
    }
    protected void setMyBody(ClientBody body)
    {
        if (body != null)
        {
            myBody = (ClientBody)body;
            myBodyGhost = (ClientBody)bstage.createBodyInstance(myBody.getType());
            myBodyGhost.set(myBody);
            energy = myBody.getEnergy();
        }
        else
        {
            myBody = null;
            myBodyGhost = null;
        }
    }
    public void run()
    {
        super.run();

        proceedPrepare();
        
        PacketManager packetManager = new PacketManager(dataManager);
        DataOutputStream recordStream = null;

        goflag = true;

        currenttime = BakutanClock.getCurrenttime();
        timelimit = currenttime;
        lastUpdateTime = currenttime;
        //lastVelocityUpdateTime = currenttime;
        long lastSendTime = currenttime;
        long lastKnockTime = currenttime;
        long recordTimer = 0;

        BVector2f lastSendVelocity = new BVector2f();
        BVector2f lastSendDirection = new BVector2f();
        Body lastCollidWith = null;

        int myBodyID = -1;

        boolean[] actions;
        BVector2f actionTargetPoint = new BVector2f();
        BVector2f inputVelocity = new BVector2f();
        actions = new boolean[10];
        long stopFlagTime = 0l;
        int actionLock = 0;
        
        if (gameOption.getAiInterface() == null)
        {
            gameOption.setAiInterface(bstage.createDefaultAIInterface());
        }
        
        //long lastGC = currenttime;
        while(goflag)
        {
//            if (currenttime - lastGC > 10000)
//            {
//                Runtime runtime = Runtime.getRuntime();
//                long free = runtime.freeMemory();
//                long max = runtime.maxMemory();
//                double remain = (double)free/(double)max;
//                System.out.println(""+free+"/"+max);
//                System.gc();
//                lastGC = currenttime;
//            }
            lastUpdateTime = currenttime;
            currenttime = BakutanClock.getCurrenttime();
            //currenttime = System.currentTimeMillis();
            
            timelimit -= currenttime - lastUpdateTime;
            
            if (!stopFlag)
            {
                // proccess user input
                proceedUserInput(actions, actionTargetPoint, inputVelocity);
            }
            else if (currenttime - stopFlagTime > 5000)
            {
                goflag = false;
            }
            //move and action
            if (!viewMode && myBody != null && !stopFlag)
            {
                //about ai
                AIInterface aiInterface = gameOption.getAiInterface();
                if (aiInterface != null)
                {
                    if (aiInterface.isRecordAI() && gameOption.isRecordAI())
                        aiInterface.setRecordAI(gameOption.isRecordAI());
                    if (gameOption.isRecordAI() || gameOption.isWorkAI())
                    {
                        aiInterface.input(new BodyInfoForAI(myBodyGhost), new BStageInfoForAI(bstage), currenttime, actionLock, energy);
                    }
                    if (aiInterface.isRecordAI())
                    {
                        AIOutput aiout = new AIOutput();
                        aiout.getVelocity().set(inputVelocity);
                        aiout.setAction(-1);
                        for (int i=0;i<actions.length;i++)
                        {
                            if (actions[i])
                            {
                                aiout.setAction(i);
                                break;
                            }
                        }
                        aiout.getActiontarget().set(actionTargetPoint);
                        aiInterface.inputDesired(currenttime, aiout);
                    }
                    if (gameOption.isWorkAI())
                    {
                        
                        for (int i=0;i<actions.length;i++)
                        {
                            actions[i] = false;
                        }
    //                        moveByMouse = false;
                        AIOutput out = aiInterface.getAIOutput();
    
                        inputVelocity.set(out.getVelocity());
                        //lastVelocityUpdateTime = lastUpdateTime + 1;
                        
                        actionTargetPoint.set(out.getActiontarget());
                        byte action = out.getAction();
                        if (0 <= action && action < actions.length)
                            actions[action] = true;
                    }
                }

                energy += myBody.getEnergyCharge() * (float)(currenttime - lastUpdateTime) / 1000f;
                if (energy > myBody.getMaxEnergy())
                {
                    energy = myBody.getMaxEnergy();
                }
                actionLock -= (int)(currenttime - lastUpdateTime);
                if (actionLock < 0)
                    actionLock = 0;
                //move
                BVector2f direction = new BVector2f(myBodyGhost.getDirection());
                {
                    float s = inputVelocity.getLength();
                    if (s > 1f)
                    {
                        inputVelocity.normalize();
                    }
                    if (s > 0f)
                        direction.set(inputVelocity);

                    inputVelocity.scale(myBodyGhost.getMaxSpeed());
                }
                BVector2f pos = new BVector2f(myBodyGhost.getPosition());
                boolean isCollid = false;
                if (myBody.isState(Body.STATE_DEAD) || myBody.isState(Body.STATE_WIN))
                {
                    myBodyGhost.getVelocity().set(0,0);
                }else
                {
                    Body collidWith = null;
                    myBodyGhost.setVelocity(inputVelocity);
                    myBodyGhost.setDirection(direction);
                    {
                        BPickResult bpr = bstage.estimateCollision(myBodyGhost);
                        int count = 0;
                        BVector2f n2 = new BVector2f(0,0);
                        while (bpr.getSize() > 0)
                        {
                            if (count > 20)
                            {
                                break;
                            }
                            BPickIntersection bpi = bpr.removeFirst();
                            long t = (long)(bpi.getDistance() * 1000f);
                            long collisionTime = myBodyGhost.getLastUpdate() + t;
                            if (collisionTime > currenttime)
                            {
                                break;
                            }
                            count++;
                            collidWith = bpi.getBody();
                            myBodyGhost.update(collisionTime);
                            bstage.updateAll(collisionTime);
                            BVector2f m = new BVector2f();
                            BVector2f n = new BVector2f();
                            boolean flag = BMath.calcNormal(n, m, myBodyGhost.getPosition(), myBodyGhost.getShape(), bpi.getBody().getPosition(), bpi.getBody().getShape());
                            m.set(myBodyGhost.getVelocity());
                            float speed = m.getLength();
                            if (speed > 0 && flag)
                            {
                                n2.add(n);
                                float dot = -BVector2f.getDot(m,n) + -0.1f;
                                if (dot < 0)
                                {
                                    m.set(myBodyGhost.getVelocity());
                                    m.scaleAdd(dot,n);
                                    //System.out.println(""+count+m+(long)(bpi.getDistance() * 1000f));
                                    if (!m.isZeroVector())
                                    {
                                        m.normalize();
                                        m.scale(speed);
                                    }
                                    myBodyGhost.setVelocity(m);
                                }
                            }else
                            {
                                myBodyGhost.getVelocity().set(0,0);
                            }
                            if (t > 0)
                            {
                                bpr = bstage.estimateCollision(myBodyGhost);
                            }
                        }
                        if (count > 1)
                        {
                            //System.out.println(""+count + n2);
                            BVector2f m = new BVector2f(myBodyGhost.getVelocity());
                            float speed = m.getLength();
                            if (speed > 0 && !n2.isZeroVector())
                            {
                                n2.add(n2);
                                float dot = -BVector2f.getDot(m,n2) + -0.1f;
                                if (dot < 0)
                                {
                                    m.set(myBodyGhost.getVelocity());
                                    m.scaleAdd(dot,n2);
                                    //System.out.println(""+count+m+(long)(bpi.getDistance() * 1000f));
                                    if (!m.isZeroVector())
                                    {
                                        m.normalize();
                                        m.scale(speed);
                                    }
                                    myBodyGhost.setVelocity(m);
                                }
                            }
                        }
                    }
                    if (collidWith == null || !collidWith.doPushReport())
                    {
                        lastCollidWith = null;
                    }
                    else if (collidWith != lastCollidWith)
                    {
                        lastCollidWith = collidWith;
                        BodyPushEvent bpe = new BodyPushEvent(collidWith.getID());
                        dataFlusher.sendPacket(packetManager.makePacket(bpe));
                    }
                }
                
                //send move event to server
                if ((currenttime > lastSendTime + DataManager.MIM_MOVE_REPORT_INTERVAL &&
                    (!(myBodyGhost.getVelocity().equals(lastSendVelocity))
                    || !(myBodyGhost.getDirection()).equals(lastSendDirection)
                    || isCollid))
                    || currenttime > lastSendTime + DataManager.MAX_MOVE_REPORT_INTERVAL
                    )
                {
                    lastSendVelocity.set(myBodyGhost.getVelocity());
                    lastSendDirection.set(myBodyGhost.getDirection());
                    BodyMoveEvent bme;
                    //bme = new BodyMoveEvent(myBodyGhost.getPosition(),myBodyGhost.getVelocity(),myBodyGhost.getDirection());
                    bme = new BodyMoveEvent(pos, myBodyGhost.getVelocity(),myBodyGhost.getDirection());
                    dataFlusher.sendPacket(packetManager.makePacket(bme));
                    lastSendTime = currenttime;
                }
                if (currenttime - lastKnockTime > 1000)
                {
                    BodyKnock bk = new BodyKnock();
                    dataFlusher.sendPacket(packetManager.makePacket(bk));
                    lastKnockTime = currenttime;
                    enQueueKnockTime(currenttime);
                }
                //send action event to server
                for (int i=0;i<actions.length;i++)
                {
                    if (actions[i])
                    {
                        actions[i] = false;
                        int j = bstage.getClientActionHook(myBody, i);
                        actions[j] = true;
                    }
                }
                for (byte i=0;i<actions.length;i++)
                {
                    if (actionLock > 0)
                        break;
                    if (actions[i])
                    {
                        if (!myBody.isActionableForClient(i,energy,actionLock))
                            continue;
                        actions[i] = false;
                        BodyActionEvent bae = new BodyActionEvent(myBody.getPosition(),actionTargetPoint, (byte)i);
                        dataFlusher.sendPacket(packetManager.makePacket(bae));
                        actionLock += myBody.getActionLockTime(i);
                        energy -= myBody.getEnergyConsumption(i);
                    }
                }

                if (message != null)
                {
                    BodyCommandEvent bce = new BodyCommandEvent(message);
                    dataFlusher.sendPacket(packetManager.makePacket(bce));
                    message = null;
                }
                myBodyGhost.update(currenttime);
            }
            bstage.updateAll(currenttime);
            
            //update all bodys
            //bstage.updateAll(currenttime);
            
            synchronized(stageEvents)
            {
                int soundRag = 0;
                while(stageEvents.size() > 0)
                {
                    ClientStageEvent cse = (ClientStageEvent)stageEvents.remove(0);
                    if (recordStream != null)
                    {
                        try
                        {
                            long t = cse.getGenerationTime();
                            if (t-recordTimer < 0)
                                recordStream.writeInt(0);
                            else
                                recordStream.writeInt((int)(t - recordTimer));
                            recordTimer = t;
                            byte[] packet = packetManager.makePacket(cse);
                            recordStream.writeInt(packet.length);
                            recordStream.write(packet);
                        }
                        catch(IOException e)
                        {
                            e.printStackTrace();
                            try
                            {
                                recordStream.close();
                            }catch(IOException e2)
                            {
                                e2.printStackTrace();
                            }
                            recordStream = null;
                        }
                    }
                    BodyEvent event = cse.getBodyEvent();
                    Body[] cbs = new Body[cse.getBodysID().length];
                    for (int i=0;i<cbs.length;i++)
                    {
                        cbs[i] = bstage.getBody(cse.getBodysID()[i]);
                    }
                    if (cbs.length > 0)
                    {
                        if (cbs[0] != null)
                        {
                            Body body = cbs[0];
                            if (event instanceof BodySmallActionEvent)
                            {
                                BodySmallActionEvent bsae = (BodySmallActionEvent)event;
                                event = new BodyActionEvent(body.getPosition(), body.getPosition(), bsae.getAction());
                            }
                            //body.actionForClient(event, baudio, characterImageBundle, effectBundle, userinterface, currenttime);
                            proceedActionForClient(event, body, currenttime);
                            if (event instanceof BodyActionEvent)
                            {
                                BodyActionEvent bae = (BodyActionEvent)event;
                                byte action = bae.getAction();
                                body.addActionLockEnergy(-body.getEnergyConsumption(action), body.getActionLockTime(action));
                            }
                        }
                    }
                    if (event instanceof BodyAddEvent)
                    {
                        BodyAddEvent bae = (BodyAddEvent)event; 
                        Body sb = bae.getBody();
                        proceedBodyAdd(sb);
                        if (sb.getType() == bstage.getRemoteClientBodyType())
                        {
                            userinterface.outputMessage(userinterface.translate("others_login", new String[]{sb.getName(), String.valueOf(sb.getID())}));
                        }
                        sb.setLastStateChange(currenttime);
                        if (sb.getID() == myBodyID)
                        {
                            setMyBody((ClientBody)sb);
                            //showMarker = currenttime + SHOW_MARKER_TIME;
                            proceedShowMarker();
                        }
                        sb.setCurrentTime(currenttime);
                        bstage.addBody(sb);
                        //sb.actionForClient(event, baudio, characterImageBundle, effectBundle, userinterface, currenttime);
                        proceedActionForClient(event, sb, currenttime);
                    }
                    else if (event instanceof BodyMultiAddEvent)
                    {
                        BodyMultiAddEvent bmae = (BodyMultiAddEvent)event; 
                        Body[] bodys = bmae.getBodys();
                        for (int i=0;i<bodys.length;i++)
                        {
                            Body sb = bodys[i];
                            proceedBodyAdd(sb);
//                            CharacterImage ci = characterImageBundle.getCharacterImage(sb.getType());
//                            if (ci != null)
//                            {
//                                sb.setCharacterImage(ci);
//                            }
                            if (sb.getType() == bstage.getRemoteClientBodyType())
                            {
                                userinterface.outputMessage(userinterface.translate("others_login", new String[]{sb.getName(), String.valueOf(sb.getID())}));
                            }
                            sb.setLastStateChange(currenttime);
                            if (sb.getID() == myBodyID)
                            {
                                setMyBody((ClientBody)sb);
                                
                                //showMarker = currenttime + SHOW_MARKER_TIME;
                                proceedShowMarker();
                            }
                            //System.out.println(""+ sb + sb.getID());
                            sb.setCurrentTime(currenttime);
                            bstage.addBody(sb);
                            //sb.actionForClient(event, baudio, characterImageBundle, effectBundle, userinterface, currenttime);
                            BodyAddEvent bae = new BodyAddEvent(sb);
                            proceedActionForClient(bae, sb, currenttime);
                        }
                    }
                    else if (event instanceof BodyClientIDEvent)
                    {
                        BodyClientIDEvent bcie = (BodyClientIDEvent)event;
                        myBodyID = bcie.getId();
                        Body body = bstage.getBody(myBodyID);
                        setMyBody((ClientBody)body);
                        
                        proceedShowMarker();
                        //showMarker = currenttime + SHOW_MARKER_TIME;
                    }
                    else if (event instanceof BodyDeleteEvent)
                    {
                        BodyDeleteEvent bde = (BodyDeleteEvent)event; 
                        Body body = cbs[0];
                        if (body.getType() == bstage.getRemoteClientBodyType())
                        {
                            userinterface.outputMessage(userinterface.translate("others_logout", new String[]{body.getName()}));
                        }
                        if (body.getID() == myBodyID)
                        {
                            setMyBody(null);
                        }
                        bstage.removeBody(body);
                        body.setBstage(null);
                    }
                    else if (event instanceof BodyMoveEvent)
                    {
                        BodyMoveEvent bme = (BodyMoveEvent)event;
                        cbs[0].setPosition(bme.getPosition());
                        cbs[0].setVelocity(bme.getVelocity());
                        cbs[0].setDirection(bme.getDirection());
                        cbs[0].setCurrentTime(cse.getGenerationTime());
                    }
                    else if (event instanceof BodySetPotisionEvent)
                    {
                        BodySetPotisionEvent bse = (BodySetPotisionEvent)event;
                        cbs[0].setPosition(bse.getPosition());
                        cbs[0].getVelocity().set(0,0);
                        if (cbs[0] == myBody)
                        {
                            myBodyGhost.setPosition(bse.getPosition());
                            myBodyGhost.getVelocity().set(0,0);
                        }
                    }
                    else if (event instanceof BodyStateEvent)
                    {
                        BodyStateEvent bse = (BodyStateEvent)event;
                        Body tg = cbs[0];
                        switch(bse.getType())
                        {
                        case Body.SET:
                            tg.setState(bse.getState());
                            if (tg == myBody
                                    && ((bse.getState() & Body.STATE_DEAD) == Body.STATE_DEAD))
                                {
                                    proceedShowMarker();
                                    //System.gc();
                                    //showMarker = currenttime + SHOW_MARKER_TIME;
                                }
                            break;
                        case Body.ENABLE:
                            tg.enableState(bse.getState());
                            break;
                        case Body.DISABLE:
                            tg.disableState(bse.getState());
                            if (tg == myBody
                                && ((bse.getState() & Body.STATE_DEAD) == Body.STATE_DEAD || (bse.getState() & Body.STATE_WIN) == Body.STATE_WIN))
                            {
                                proceedShowMarker();
                                //showMarker = currenttime + SHOW_MARKER_TIME;
                            }
                            break;
                        }
                    }else if (event instanceof BodyOptionEvent)
                    {
                        BodyOptionEvent boe = (BodyOptionEvent)event;
                        cbs[0].setOption(boe.getType(), boe.getValue());
                    }else if (event instanceof BodyArmorEvent)
                    {
                        BodyArmorEvent bhe = (BodyArmorEvent)event;
                        Body to = cbs[0];
                        if (bhe.getType() == BodyArmorEvent.SUB)
                        {
                            to.setArmor(to.getArmor() - bhe.getArmor());
                            if (to == myBody)
                            {
                                redout += bhe.getArmor()*10;
                                if (redout > 1000)
                                    redout = 1000;
                            }
                        }
                        else if (bhe.getType() == BodyArmorEvent.ADD)
                        {
                            to.setArmor(to.getArmor() + bhe.getArmor());
                        }
                        else if (bhe.getType() == BodyArmorEvent.SET)
                        {
                            to.setArmor(bhe.getArmor());
                        }
                    }
                    else if (event instanceof BodyMessageEvent)
                    {
                        BodyMessageEvent bme = (BodyMessageEvent)event;
                        if (bme.getType() == DataManager.MESSAGE_SYSTEM)
                        {
                            //userinterface.outputMessage("System message:" + bme.getMessage());
                            userinterface.outputMessage(userinterface.translate("system_message", new String[]{bme.getMessage()}));
                        }
                        else if (bme.getType() == DataManager.MESSAGE_LOGIN)
                        {
                            userinterface.outputMessage(userinterface.translate("login_message", new String[]{bme.getMessage()}));
                        }
                        else if (bme.getType() == DataManager.MESSAGE_NOTE)
                        {
                            userinterface.outputMessage(userinterface.translate("note_message", new String[]{bme.getMessage()}));
                        }
                        else if (bme.getType() == DataManager.MESSAGE_CHAT)
                        {
                            cbs[0].setMessage(currenttime, bme.getMessage());
                            userinterface.outputMessage(userinterface.translate("say", new String[]{cbs[0].getName(), bme.getMessage()}));
                            //userinterface.outputMessage("[" + cbs[0].getName() + "] " + bme.getMessage());
                        }
                    }
                    else if (event instanceof BodyStageMessageEvent)
                    {
                        BodyStageMessageEvent bme = (BodyStageMessageEvent)event;
                        bstage.setStageMessage(bme.getType(), bme.getMessage());
                    }
                    else if (event instanceof BodyScoreEvent)
                    {
                        BodyScoreEvent bse = (BodyScoreEvent)event;
                        for (int i=0;i<bse.getScores().length;i++)
                        {
                            //TODO ここでNullPointerExceptionのエラーあり
                            cbs[i].setScore(bse.getScores()[i]);
                        }
                    }
                    else if (event instanceof BodyActionEvent)
                    {
                    }
                    else if (event instanceof BodySoundEvent)
                    {
                        BodySoundEvent bse = (BodySoundEvent)event;
                        if (cbs.length > 0)
                            proceedSoundEvent(bse, cbs[0], 0);
                        else
                            proceedSoundEvent(bse, null, 0);
                        //baudio.play(bse.getSound(), 0);
                    }
                    else if (event instanceof GameSetEvent)
                    {
                        GameSetEvent gse = (GameSetEvent)event;
                        timelimit = gse.getTimeLimit();
                        if (timelimit == 0)
                        {
                            userinterface.outputMessage(userinterface.translate("game_set"));
                            Body[] bodys = bstage.getBodys();
                            BVector2f velocity = new BVector2f(0,0);
                            for (int i=0;i<bodys.length;i++)
                            {
                                bodys[i].setVelocity(velocity);
                            }
                            stopFlag = true;
                            stopFlagTime = currenttime;
                            restart = true;
                        }
                    }
                    else if (event instanceof DisconnectEvent)
                    {
                        Body[] bodys = bstage.getBodys();
                        BVector2f velocity = new BVector2f(0,0);
                        for (int i=0;i<bodys.length;i++)
                        {
                            bodys[i].setVelocity(velocity);
                        }
                        stopFlag = true;
                        stopFlagTime = currenttime;
                        restart = false;
                    }
                    else if (event instanceof BodyActionLockEnergyEvent)
                    {
                        BodyActionLockEnergyEvent balae = (BodyActionLockEnergyEvent)event;
                        actionLock += balae.getActionLock();
                        energy += balae.getEnergy();
                    }
                    else if (event instanceof BodyKnock)
                    {
                        if (!viewMode)
                            rag = (int)(currenttime - deQueueKnockTime()) / 2;
                    }
                    else
                    {
                        System.out.println("unknown event : "+cse+" : "+cse.getBodyEvent()
                                + " : " + event
                                + " : " + cse.getBodysID());
                    }
                }
                stageEvents.clear();
            }
            //start record replay
            if (gameOption.isRecordReplay())
            {
                if (recordStream == null)
                {
                    SimpleDateFormat format = new SimpleDateFormat("yyyyMMddHHmmss");
                    File recordFile = new File(userinterface.getWorkDir()
                            + "/replay/" + DataManager.getBuildNumber() + "_" + format.format(new Date()) + ".replay");
                    try
                    {
                        if (recordFile.exists() || !recordFile.createNewFile())
                        {
                            gameOption.setRecordReplay(false);
                        }
                        else
                        {
                            recordStream = new DataOutputStream(new GZIPOutputStream(new FileOutputStream(recordFile),2<<12));
                            Body[] bodys = bstage.getBodys();
                            byte[] protocolPacket = packetManager.makePacket(DataManager.getCurrentProtocolVersion());
                            byte[] bstagePacket = packetManager.makePacket(bstage);
                            byte[] bodysPacket = packetManager.makePacket(bodys);
                            recordStream.writeInt(0); //rag of first packet
                            recordStream.writeInt(protocolPacket.length + bstagePacket.length + bodysPacket.length);
                            recordStream.write(protocolPacket);
                            recordStream.write(bstagePacket);
                            recordStream.write(bodysPacket);
                            
                            ClientStageEvent csegse = new ClientStageEvent(new int[0],new GameSetEvent(timelimit));
                            byte[] timelimitPacket = packetManager.makePacket(csegse);
                            recordStream.writeInt(0);
                            recordStream.writeInt(timelimitPacket.length);
                            recordStream.write(timelimitPacket);

                            if (myBody != null)
                            {
                                ClientStageEvent csebcie = new ClientStageEvent(new int[0],new BodyClientIDEvent(myBody.getID()));
                                byte[] clientIdPacket = packetManager.makePacket(csebcie);
                                recordStream.writeInt(0);
                                recordStream.writeInt(clientIdPacket.length);
                                recordStream.write(clientIdPacket);
                            }
                            userinterface.outputMessage(userinterface.translate("recording_to", new String[]{recordFile.toString()}));
                            recordTimer = currenttime;
                        }
                    }catch(IOException e)
                    {
                        e.printStackTrace();
                        gameOption.setRecordReplay(false);
                        if(recordStream != null)
                        {
                            try
                            {
                                recordStream.close();
                            }catch(IOException e2)
                            {
                                e2.printStackTrace();
                            }
                            recordStream = null;
                        }
                    }
                }
            }
            else
            {
                if (recordStream != null)
                {
                    try
                    {
                        recordStream.close();
                    }catch(IOException e2)
                    {
                        e2.printStackTrace();
                    }
                    recordStream = null;
                }
            }
            
            
            if (myBody != null)
            {
                if (viewMode)
                    myBodyGhost.set(myBody);
                else
                    myBodyGhost.setWithoutPosition(myBody);
            }
            
            proceedDraw();

            redout -= currenttime - lastUpdateTime;
            if (redout < 0)
            {
                redout = 0;
            }
            long intervalDerey = gameOption.getIntervalDerey();
            intervalDerey += gameOption.getInterval() - (currenttime - lastUpdateTime);
            gameOption.setIntervalDerey(intervalDerey);
            if (intervalDerey > 0)
            {
                try
                {
                    Thread.sleep(intervalDerey);
                }catch(InterruptedException e)
                {
                    e.printStackTrace();
                }
            }
            else
            {
                gameOption.setIntervalDerey(0);
            }
        }
        if (recordStream != null)
        {
            try
            {
                recordStream.close();
            }
            catch(IOException e)
            {
            }
        }
        proceedDispose();
        if (!viewMode)
        {
            if (restart)
            {
                GameRestartEvent gre = new GameRestartEvent();
                dataFlusher.sendPacket(packetManager.makePacket(gre));
            }
        }
    }
    public void putStageEvent(ClientStageEvent se)
    {
        synchronized(stageEvents)
        {
            stageEvents.add(se);
        }
    }
    public void setDrawOptionEx(boolean value, int type)
    {
        if (bstage == null)
            return;
        bstage.setDrawOption(value, type);
    }
    public boolean checkDrawOption(int type)
    {
        if (bstage == null)
            return false;
        return bstage.isDrawOption(type);
    }
    public void setMessage(String message) {
        this.message = message;
    }
    private void enQueueKnockTime(long time)
    {
        knockTime[knockTimeWrite++] = time;
        if (knockTimeWrite >= knockTime.length)
            knockTimeWrite = 0;
    }
    private long deQueueKnockTime()
    {
        long time = knockTime[knockTimeRead++];
        if (knockTimeRead >= knockTime.length)
            knockTimeRead = 0;
        return time;
    }
    public int getRag()
    {
        return rag;
    }
    public void setRag(int rag)
    {
        this.rag = rag;
    }
}
