/*
 * 作成日: 2006/11/24
 *
 * 
 * ウィンドウ - 設定 - Java - コード・スタイル - コード・テンプレート
 */
package bakutan.common.ai;

import bakutan.common.math.BVector2f;

public class AIOutput
{
    private BVector2f velocity = new BVector2f();
    private BVector2f actiontarget = new BVector2f();
    private byte action = -1;
    
    public AIOutput()
    {
        super();
    }
    
    /**
     * アクションを取得する。何も設定されていないときは-1を返す。
     * @return アクション
     */
    public byte getAction()
    {
        return action;
    }
    /**
     * アクションを設定する。
     * @param action 設定するアクション
     */
    public void setAction(int action)
    {
        this.action = (byte)action;
    }

    /**
     * アクションターゲットの位置を得る。
     * @return アクションターゲットの位置
     */
    public BVector2f getActiontarget()
    {
        return new BVector2f(actiontarget);
    }

    /**
     * アクションターゲットの位置を設定する。
     * @param actiontarget 設定するアクションターゲットの位置。
     */
    public void setActiontarget(BVector2f actiontarget)
    {
        this.actiontarget.set(actiontarget);
    }

    /**
     * 移動の速度を得る。
     * @return 移動の速度
     */
    public BVector2f getVelocity()
    {
        return velocity;
    }

    /**
     * 移動の速度を設定する。ベクトルの長さは0〜1の範囲であり、1以上のときは1にスケーリングされる。
     * @param velocity 設定する速度。
     */
    public void setVelocity(BVector2f velocity)
    {
        this.velocity = velocity;
    }
}
