/*
 * 作成日: 2006/11/30
 */
package bakutan.common.ai;

import java.util.Comparator;

import bakutan.common.math.BVector2f;

/**
 * 
 * @author cattaka
 *
 * targetで指定した位置の順に並び替えをするためのComparator。
 * 集合を作成した後でsetTarget(BVector2f)を呼び出すと
 * 整合性が狂うので注意すること。
 */
public class BodyInfoForAIComparator implements Comparator<BodyInfoForAI>
{
    private BVector2f target = new BVector2f();
    public BodyInfoForAIComparator()
    {
    }
    
    public void setTarget(BVector2f target)
    {
        this.target.set(target);
    }
    
    public int compare(BodyInfoForAI b1, BodyInfoForAI b2)
    {
        double d1 = BVector2f.getDistance(target,b1.getRawPosition());
        double d2 = BVector2f.getDistance(target,b2.getRawPosition());
        if (d1 == d2)
            return 0;
        else if (d1 > d2)
            return 1;
        else
            return -1;
    }
}
