/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/01/19
 */
package bakutan.common.event;

import bakutan.common.BStage;
import bakutan.common.Body;
import bakutan.common.DataManager;
import bakutan.common.EventThread;
import bakutan.common.math.BVector2f;

/**
 * @author cattaka
 */
public class BodySoundEvent implements BodyEvent
{
    public static final byte MODE_TARGET = 0;
    public static final byte MODE_POSITION = 0;
    private byte sound;
	private BVector2f position = new BVector2f();
    private byte mode;
    
    public BodySoundEvent(byte sound)
    {
        this.sound = sound;
        this.mode = MODE_TARGET;
    }
	public BodySoundEvent(byte sound, BVector2f pos)
	{
		this.sound = sound;
        this.position.set(pos);
        this.mode = MODE_POSITION;
	}
	public byte getSound()
	{
		return sound;
	}
    
	public byte getMode()
    {
        return mode;
    }
    public BVector2f getPosition()
    {
        return position;
    }
    public void perform(BStage bstage, EventThread eventThread, Body[] bodys)
	{
	}
    public byte getEventID()
    {
        return DataManager.EVENT_SOUND;
    }
}
