/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/01/11
 *
 */
package bakutan.common.event;

import bakutan.common.Body;

/**
 * @author cattaka
 *
 */
public class StageEvent
{
	private long generationTime;
	private long createTime;
	StageEvent next;
	//private StageEvent prev;
	private Body[] target;
	private BodyEvent bodyEvent;
	//private boolean consumed = false;

	public StageEvent(long createTime, long generationTime)
	{
		this.createTime = createTime;
		this.generationTime = generationTime;
	}
	
	public StageEvent(Body[] target, BodyEvent bodyEvent, long createTime, long generationTime)
	{
		this.target = target;
		this.bodyEvent = bodyEvent;
		this.createTime = createTime;
		this.generationTime = generationTime;
	}
	
	public StageEvent getNext()
	{
		return next;
	}
    public void setGenerationTime(long generationTime)
    {
        this.generationTime = generationTime;
    }
    
//	public StageEvent getPrev()
//	{
//		return prev;
//	}
    
//	public static void setChain(StageEvent prev,StageEvent next)
//	{
//		prev.next = next;
//		next.prev = prev;
//	}
	public void removeNext()
	{
//		if (this.prev != null && this.next != null)
//		{
//			this.prev.next = this.next;
//			this.next.prev = this.prev;
//		}else if(this.prev != null)
//		{
//			this.prev.next = null;
//		}else if(this.next != null)
//		{
//			this.next.prev = null;
//		}
        if (next != null)
        {
            if (next.next != null)
                this.next = this.next.next;
            else
                this.next = null;
        }
	}
	public long getGenerationTime()
	{
		return generationTime;
	}
	
	public void addNear(StageEvent be)
	{
		if (next == null)
		{
		    //setChain(this,be);
            this.next = be;
		}else
		{
			if (be.getGenerationTime() < next.getGenerationTime())
			{
//				setChain(be,next);
//				setChain(this,be);
                be.next = this.next;
                this.next = be;
			}else
			{
                StageEvent n = next;
                while(true)
                {
                    if (n.next == null)
                    {
                        //setChain(n,be);
                        n.next = be;
                        break;
                    }
                    else
                    {
                        if (be.getGenerationTime() < n.next.getGenerationTime())
                        {
                            //setChain(be,n.next);
                            //setChain(n,be);
                            be.next = n.next;
                            n.next = be;
                            break;
                        }
                        else
                        {
                            n = n.next;
                        }
                    }
                }
                //next.addNear(be);
			}
		}
	}
	public BodyEvent getBodyEvent()
	{
		return bodyEvent;
	}
	public Body[] getTargets()
	{
		return target;
	}
	/*
	public boolean isConsumed() {
		return consumed;
	}
	public void setConsumed(boolean consumed) {
		this.consumed = consumed;
	}
	*/
	public long getCreateTime() {
		return createTime;
	}
//    public void setNext(StageEvent next)
//    {
//        this.next = next;
//    }
    public void dispose()
    {
        bodyEvent = null;
        next = null;
        target = null;
    }
}
