/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/01/18
 */
package bakutan.common.graphics;

import java.awt.Image;

import bakutan.common.Body;

/**
 * @author cattaka
 */
public interface CharacterImage
{
	public static final int WIN = 0;
	public static final int WINSTOP = 1;
	public static final int DEAD = 2;
	public static final int DEADSTOP = 3;
	public static final int RIGHT = 4;
	public static final int UP = 5;
	public static final int LEFT = 6;
	public static final int DOWN = 7;
	public static final int MOVERIGHT = 8;
	public static final int MOVEUP = 9;
	public static final int MOVELEFT = 10;
	public static final int MOVEDOWN = 11;
	
	public static final int UPRIGHT = 12;
	public static final int UPLEFT = 13;
	public static final int DOWNLEFT = 14;
	public static final int DOWNRIGHT = 15;
	public static final int MOVEUPRIGHT = 16;
	public static final int MOVEUPLEFT = 17;
	public static final int MOVEDOWNLEFT = 18;
	public static final int MOVEDOWNRIGHT = 19;

	public static final int DEADRIGHT = 20;
	public static final int DEADUP = 21;
	public static final int DEADLEFT = 22;
	public static final int DEADDOWN = 23;
	public static final int DEADRIGHTSTOP = 20;
	public static final int DEADUPSTOP = 21;
	public static final int DEADLEFTSTOP = 22;
	public static final int DEADDOWNSTOP = 23;

	public static final int DEADUPRIGHT = 24;
	public static final int DEADUPLEFT = 25;
	public static final int DEADDOWNLEFT = 26;
	public static final int DEADDOWNRIGHT = 27;
	public static final int DEADUPRIGHTSTOP = 28;
	public static final int DEADUPLEFTSTOP = 29;
	public static final int DEADDOWNLEFTSTOP = 30;
	public static final int DEADDOWNRIGHTSTOP = 31;
	
	
	public Image[] getImages(int state);
	public Image getImages(Body body, int count);
	public int getHeight();
	public int getWidth();
    public void dispose();
}
