/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/02/15
 */
package bakutan.common.serverinfo;

import java.util.ArrayList;

import bakutan.common.BodyState;


/**
 * @author cattaka
 */
public class BStageState extends SmallBStageState
{
	private String loginMessage = "";
	private String noteMessage = "";
    private int maxClients;
	private ArrayList<BodyState> bodyStates = new ArrayList<BodyState>();
    
	public BStageState()
	{
	}
    public void setMaxClients(int maxClients)
    {
        this.maxClients = maxClients;
    }
    public int getMaxClients()
    {
        return maxClients;
    }
	public BodyState[] getBodyStates()
	{
		BodyState[] bss = new BodyState[bodyStates.size()];
		System.arraycopy(bodyStates.toArray(), 0, bss, 0, bss.length);
		return bss;
	}
	public void addBodyState(BodyState bs)
	{
		bodyStates.add(bs);
	}
	public String getLoginMessage()
	{
		return loginMessage;
	}
	public void setLoginMessage(String loginMessage)
	{
		if (loginMessage == null)
			throw new NullPointerException();
		this.loginMessage = loginMessage;
	}
	public String getNoteMessage()
	{
		return noteMessage;
	}
	public void setNoteMessage(String noteMessage)
	{
		if (noteMessage == null)
			throw new NullPointerException();
		this.noteMessage = noteMessage;
	}
}
