/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/02/04
 */
package bakutan.common.util;

import java.util.HashMap;
import java.util.Random;

import javax.sound.midi.Sequence;

/**
 * @author cattaka
 */
public class BGMBundle
{
	private HashMap<Byte, Sequence> hashMap = new HashMap<Byte, Sequence>();
	private Random rand;
    
	public BGMBundle()
	{
        rand = new Random(System.currentTimeMillis());
	}
	public Sequence putBGM(byte type, Sequence bgmData)
	{
		return (Sequence)hashMap.put(new Byte(type), bgmData);
	}
	public Sequence getBGM(byte type)
	{
		return hashMap.get(type);
	}
	public Sequence getRandom()
	{
		Sequence[] seqs = hashMap.values().toArray(new Sequence[hashMap.values().size()]);
		if (seqs.length == 0)
		{
			return null;
		}
		int p = (rand.nextInt(seqs.length));
        return seqs[p];
	}
    public void dispose()
    {
        hashMap.clear();
    }
}
