package bakutan.common.util;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class MD5Tool {
    public static byte[] makeHash(byte[] arg)
    {
        try
        {
            MessageDigest md = MessageDigest.getInstance("MD5");
            return  md.digest(arg);
        }catch(NoSuchAlgorithmException e)
        {
            return null;
        }
    }
    public static byte[] makeHash(byte[] arg, byte[] key)
    {
        try
        {
            MessageDigest md = MessageDigest.getInstance("MD5");
            md.update(key);
            return md.digest(arg);
        }catch(NoSuchAlgorithmException e)
        {
            return null;
        }
    }
    public static byte[] makeBytes(String arg)
    {
        if (arg.length()%2 == 1)
            return null;
        int i = arg.length() / 2;
        byte[] b = new byte[i];
        for (i=0;i<b.length;i++)
        {
            b[i] = (byte)(Integer.parseInt(arg.substring(i*2,i*2+2),16));
        }
        return b;
    }
    public static String makeString(byte[] arg)
    {
        StringBuffer buf = new StringBuffer();
        for (int i=0;i<arg.length;i++)
        {
            int r = (arg[i] >= 0) ? arg[i]:(256+arg[i]);
            if (r < 0x10)
                buf.append("0");
            buf.append(Integer.toHexString(r));
        }
        return buf.toString();
    }
    public static String makeHashString(String arg)
    {
        return makeString(makeHash(arg.getBytes()));
    }
    
    public static void main(String[] args)
    {
        if (args.length < 1)
            return;
        for (int i=0;i<args.length;i++)
        {
            System.out.println(makeString(makeHash(args[i].getBytes())));
        }
    }
}
