/*
 * 作成日: 2007/01/30
 */
package bakutan.common.util;

import java.io.IOException;
import java.io.OutputStream;

public class NullDataFlusher implements DataFlusher
{
    private OutputStream out;
    private boolean goflag = false;
    
    public NullDataFlusher(OutputStream out)
    {
        this.out = out;
        goflag = true;
    }

    public void afterStop()
    {
    }

    public void dispose()
    {
        goflag = false;
        try
        {
            out.close();
        }
        catch(IOException e)
        {
        }
    }

    public boolean isAlive()
    {
        return goflag;
    }

    public void sendPacket(byte[] packet, boolean flush)
    {
        try
        {
            out.write(packet);
            if (flush)
                out.flush();
        }
        catch(IOException e)
        {
            dispose();
        }
    }

    public void sendPacket(byte[] packet)
    {
        try
        {
            out.write(packet);
            out.flush();
        }
        catch(IOException e)
        {
            dispose();
        }
    }

    public void start()
    {
    }

    public void waitForStop()
    {
    }
}
