/*
 * 作成日: 2007/01/07
 */
package bakutan.common.util;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;

public class TimerInputStream extends InputStream
{
    private int num = 0;
    private int left = 0;
    private InputStream in;
    private long lastReadPacketTime = -1;

    public TimerInputStream(InputStream in)
    {
        this.in = in;
    }
    @Override
    public int read() throws IOException
    {
        if (num > 0)
        {
            num--;
            return in.read();
        }
        int ch1 = in.read();
        int ch2 = in.read();
        int ch3 = in.read();
        int ch4 = in.read();
        if ((ch1 | ch2 | ch3 | ch4) < 0)
            throw new EOFException();
        int time = ((ch1 << 24) + (ch2 << 16) + (ch3 << 8) + (ch4 << 0));
        
        ch1 = in.read();
        ch2 = in.read();
        ch3 = in.read();
        ch4 = in.read();
        if ((ch1 | ch2 | ch3 | ch4) < 0)
            throw new EOFException();
        num = ((ch1 << 24) + (ch2 << 16) + (ch3 << 8) + (ch4 << 0));
        if (num < 0 || time < 0)
            throw new IOException(""+num+":"+time);
//        left += time;
//        left = timer.sleep(left);
//        System.out.println(left);
        
        long currenttime = System.currentTimeMillis();
        if (lastReadPacketTime == -1)
            lastReadPacketTime = currenttime;
        lastReadPacketTime += time;
        long sleepTime = lastReadPacketTime - currenttime;
        try
        {
            if (sleepTime > 0)
            {
                Thread.sleep(sleepTime);
            }
        }
        catch(InterruptedException e)
        {
            e.printStackTrace();
        }
        return this.read();
    }
    @Override
    public void close() throws IOException
    {
        in.close();
    }
}

