/*
 * 作成日: 2007/02/01
 */
package bakutan.common.util.datainputpanel;

import javax.swing.JComboBox;
import javax.swing.JComponent;


public class DIPInfoSelect implements DIPInfo
{
    private String label;
    private int defaultData;
    private JComboBox comboBox;
    
    public DIPInfoSelect(String label, String[] items, int defaultData) throws InvalidDataTypeException
    {
        super();
        if (label == null || items == null)
            throw new NullPointerException();
        for (int i=0;i<items.length;i++)
        {
            if (items[i] == null)
                throw new NullPointerException();
        }
        if (defaultData<0 || items.length <= defaultData)
            throw new ArrayIndexOutOfBoundsException();
        
        this.label = label;
        this.defaultData = defaultData;
        this.comboBox = new JComboBox(items);
        this.comboBox.setSelectedIndex(defaultData);
    }
    public Object getValue()
    {
        return new Integer(comboBox.getSelectedIndex());
    }
    public void setValue(int value)
    {
        if (value<0 || comboBox.getItemCount() <= value)
            throw new ArrayIndexOutOfBoundsException();
        comboBox.setSelectedIndex(value);
    }
    public void makeDefault()
    {
        this.comboBox.setSelectedIndex(defaultData);
    }
    public String getLabel()
    {
        return label;
    }
    public JComponent getComponent()
    {
        return comboBox;
    }
    public boolean isEnable()
    {
        return comboBox.isEnabled();
    }
    public void setEnable(boolean enable)
    {
        comboBox.setEnabled(enable);
    }
}
