/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/01/11
 *
 */
package bakutan.debug;

import bakutan.common.EventThread;
import bakutan.common.event.StageEvent;
import bakutan.common.util.BakutanClock;

/**
 * @author cattaka
 */
public class EventTest
{
	private EventThread et = new EventThread();
	
	public void start()
	{
		
		DebugThread dt;
		dt = new DebugThread("Thread 1", et);
		dt.start();
		dt = new DebugThread("Thread 2", et);
		dt.start();
		
		
		while(true)
		{
			DebugEvent se = (DebugEvent)et.waitForNextEvent();
			System.out.println(se.getName() + ":" + se.getGenerationTime());
		}
	}
	public static void main(String[] args)
	{
		EventTest et = new EventTest();
		et.start();
	}
}
class DebugThread extends Thread
{
	private EventThread et;
	DebugThread(String name, EventThread et)
	{
		super(name);
		this.et = et;
	}
	public void run()
	{
		while(true)
		{
			//long currenttime = System.currentTimeMillis() - (long)(200d * Math.random());
			long currenttime = BakutanClock.getCurrenttime() - (long)(200d * Math.random());
			DebugEvent se = new DebugEvent(currenttime,currenttime);
			se.setName(getName());
			et.putStageEvent(se);
		}
	}
}
class DebugEvent extends StageEvent
{
	private String name;
	
	DebugEvent(long createtime, long generationTime)
	{
		super(createtime, generationTime);
	}
	public String getName() 
	{
		return name;
	}
	public void setName(String name) 
	{
		this.name = name;
	}
}

