/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/01/18
 */
package bakutan.debug;

import java.awt.Graphics;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JFrame;

import bakutan.common.graphics.CharacterImage;
import bakutan.common.graphics.CharacterImageFD;

/**
 * @author cattaka
 */
public class ImageTest extends JFrame
{
	public ImageTest()
	{
		setSize(300,300);
	}
	public void run()
	{
		CharacterImage ci;
		try
		{
			//ci = new CharacterImage(ClassLoader.getSystemResourceAsStream("character.png"));
			ci = new CharacterImageFD(null, Transparency.BITMASK, ClassLoader.getSystemResourceAsStream("image/man1.png"));
		}catch(IOException e)
		{
			e.printStackTrace();
			return;
		}
		Graphics g = getContentPane().getGraphics();
		try
		{
			BufferedImage img = ImageIO.read(ClassLoader.getSystemResourceAsStream("man1.png"));
			System.out.println(img.getType());
			
		}catch(Exception e)
		{
			
		}
		
		boolean f = false;
		while (true)
		{
			if (f)
			{
				f = false;
				g.drawImage(ci.getImages(CharacterImage.DOWN)[0],0,0,null);
			}else
			{
				f = true;
				g.drawImage(ci.getImages(CharacterImage.DOWN)[1],0,0,null);
			}
			try
			{
				Thread.sleep(500);
			}catch(InterruptedException e)
			{
				
			}
		}
	}
	public static void main(String[] args)
	{
		ImageTest it = new ImageTest();
		it.setVisible(true);
		it.run();
	}
}
