/*
 * 作成日: 2006/12/23
 */
package bakutan.debug;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

public class RecordConverter
{
    double[][] orgInputData = new double[0][0];
    double[][] orgDesiredData = new double[0][0];
    int inputNeuronNum = 1;
    int outputNeuronNum = 1;

    public RecordConverter()
    {
        super();
    }
    public void loadRecord(File file)
    {
        ByteArrayOutputStream rawData = new ByteArrayOutputStream(1024*1024);
        try
        {
            GZIPInputStream in = new GZIPInputStream(new FileInputStream(file));
            int i;
            while((i=in.read()) != -1)
            {
                rawData.write(i);
            }
            byte[] rd = rawData.toByteArray();
            DataInputStream din = new DataInputStream(new ByteArrayInputStream(rd));
            this.inputNeuronNum = din.readInt();
            this.outputNeuronNum = din.readInt();
            int dataNum = rd.length/((Integer.SIZE/8*2) + (inputNeuronNum+outputNeuronNum)*Double.SIZE/8);
            System.out.println(""+inputNeuronNum+":"+outputNeuronNum+":"+dataNum);
            orgInputData = new double[dataNum][inputNeuronNum];
            orgDesiredData = new double[dataNum][outputNeuronNum];
            for (int j=0;j<dataNum;j++)
            {
                if (inputNeuronNum != din.readInt())
                    throw new ArrayIndexOutOfBoundsException();
                for (int k=0;k<inputNeuronNum;k++)
                {
                    orgInputData[j][k] = din.readDouble();
                }
                if (outputNeuronNum != din.readInt())
                    throw new ArrayIndexOutOfBoundsException();
                for (int k=0;k<outputNeuronNum;k++)
                {
                    orgDesiredData[j][k] = din.readDouble();
                }
            }
            in.close();
        }
        catch(IOException exc)
        {
            exc.printStackTrace();
        }
    }
    public void saveRecord(File file)
    {
        try
        {
            DataOutputStream recordStream = new DataOutputStream(new GZIPOutputStream(new FileOutputStream(file),1024*1024));
            recordStream.writeInt(inputNeuronNum);
            recordStream.writeInt(outputNeuronNum);
            for (int k=0;k<orgInputData.length;k++)
            {
                double[] ds;
                ds = orgInputData[k];
                recordStream.writeInt(ds.length);
                for (int i=0;i<ds.length;i++)
                {
                    recordStream.writeDouble(ds[i]);
                }
                ds = orgDesiredData[k];
                recordStream.writeInt(ds.length);
                for (int i=0;i<ds.length;i++)
                {
                    recordStream.writeDouble(ds[i]);
                }
            }
            recordStream.close();
        }
        catch(IOException e)
        {
            return;
        }
    }
    public static void main(String[] args)
    {
        RecordConverter rc = new RecordConverter();
        for (int i=0;i<args.length;i++)
        {
            rc.loadRecord(new File(args[0]));
            rc.saveRecord(new File(args[1]));
        }
        System.out.println("cut succeed.");
    }
}
