/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/02/15
 */
package bakutan.debug;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.net.Socket;

import bakutan.common.BodyState;
import bakutan.common.DataManager;
import bakutan.common.serverinfo.BStageState;
import bakutan.common.util.CompressedInputStream;
import bakutan.common.util.CompressedOutputStream;

/**
 * @author cattaka
 */
public class StateTest
{
	public static void main(String[] args)
	{
		try
		{
			Socket socket = new Socket("localhost", DataManager.DEFAULT_PORT);
			DataInputStream in = new DataInputStream(new CompressedInputStream(socket.getInputStream()));
			DataOutputStream out = new DataOutputStream(new CompressedOutputStream(socket.getOutputStream()));
			System.out.println(in.readUTF());
			out.writeByte(DataManager.REQUEST_BSTAGESTATE);
			out.flush();
			BStageState bss = DataManager.getBStageState("localhost",DataManager.DEFAULT_PORT, 100);
			BodyState[] bs = bss.getBodyStates();
			System.out.println("Clients:" + bs.length + "/" + bss.getMaxClients());
			for(int i=0;i<bs.length;i++)
			{
				System.out.println(bs[i].getName() + ":" + bs[i].getScore());
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
	}
}
