/*
 * 作成日: 2007/01/04
 */
package bakutan.game.deathmatch;

import java.awt.Color;
import java.awt.Graphics;

import bakutan.common.DataManager;
import bakutan.common.graphics.EffectDrawer;
import bakutan.common.math.BVector2f;

public class EffectBlast extends EffectDrawer
{
    private boolean finish = false;
    private float size = 1f;
    private double[] angle;
    private double[] colorOffset;
    private float[] speed;
    private int num;
    
    public EffectBlast(BVector2f position, BVector2f velocity, int num, float size, long currenttime)
    {
        super(currenttime);
        setLastUpdate(currenttime);
        setPosition(position);
        setVelocity(velocity);
        this.size = size;
        
        this.num = num;
        angle = new double[num];
        speed = new float[num];
        colorOffset = new double[num];
        for (int i=0;i<num;i++)
        {
            angle[i] = Math.random() * Math.PI * 2;
            speed[i] = (float)(Math.random() * size);
            colorOffset[i] = Math.random() * Math.PI * 2;
        }
    }
    @Override
    public void drawCharacter(Graphics g, long currenttime, int effectLevel)
    {
        long time = currenttime - getStartTime();
        if (time > 500)
        {
            finish = true;
            return;
        }
        float s = (float)time / 500f;
        BVector2f vec = new BVector2f();
        int limitedNum = num;
        if (effectLevel <= 3)
            limitedNum /= 2;
        for(int i=0;i<limitedNum;i++)
        {
            vec.set(0f, s * speed[i]);
            vec.rotate(angle[i]);
            int x = (int)(vec.x * DataManager.BLOCKSIZE);
            int y = (int)(vec.y * DataManager.BLOCKSIZE);
            float c = (float)(Math.cos(colorOffset[i] + s * Math.PI * 8) + 1d) / 2f;
//            if (effectLevel > 3)
//                g.setColor(new Color(1,c,0,1f-s));
//            else
//                g.setColor(new Color(1,c,0,1));
            g.setColor(new Color(1,c,0));
            g.fillOval(x-1,y-1,3,3);
        }
    }
    @Override
    public boolean isFinish(long currenttime)
    {
        return (currenttime - getStartTime() >= 500);
    }
}