/*
 * 作成日: 2007/01/04
 */
package bakutan.game.deathmatch;

import java.awt.Color;
import java.awt.Graphics;

import bakutan.common.Body;
import bakutan.common.DataManager;
import bakutan.common.graphics.EffectDrawer;
import bakutan.common.math.BVector2f;

public class EffectFierceAttack extends EffectDrawer
{
    public static final float DEFAULT_RADIUS = 5;
    
    public EffectFierceAttack(Body target, long currenttime)
    {
        super(currenttime, target);
        setLastUpdate(currenttime);
        setPosition(target.getPosition());
        setVelocity(target.getVelocity());
        setRadius(DEFAULT_RADIUS);
    }
    @Override
    public void drawCharacter(Graphics g, long currenttime, int effectLevel)
    {
        BVector2f dir = new BVector2f(0f,1f);
        int x = 0;
        int y = 0;

        long time = currenttime - getStartTime();
        float s;
        double rotate = (double)(time % 1000) / 1000d * Math.PI / 2d;
        dir.rotate(rotate);
        if (time <= 200)
        {
            
            s = (float)time / 200f;
            setRadius(s * DEFAULT_RADIUS);
            int r = (int)(DataManager.BLOCKSIZE * getRadius());
            if (effectLevel > 3)
            {
//                g.setColor(new Color(1f,0f,0f,1-s));
//                g.fillOval(x-r*4,y-r*4,r*8,r*8);
                g.setColor(new Color(1f,0f,0f,s));
            }
            else
            {
                g.setColor(new Color(1f,0f,0f));
            }
            g.drawOval(x-r,y-r,r*2,r*2);
            dir.scale(s * 5 * DataManager.BLOCKSIZE);
            int rx,ry;
            rx = (int) (dir.x);
            ry = (int) (dir.y);
            g.drawLine(x-rx, y-ry, x+rx, y+ry);
            g.drawLine(x+rx, y-ry, x-rx, y+ry);
            dir.rotate(Math.PI/2);
            rx = (int) (dir.x);
            ry = (int) (dir.y);
            g.drawLine(x-rx, y-ry, x+rx, y+ry);
            g.drawLine(x+rx, y-ry, x-rx, y+ry);
        }
        else
        {
            s = 1f - (float)(time) / 30000f;
            setRadius(s * DEFAULT_RADIUS);
            int r = (int)(DataManager.BLOCKSIZE * getRadius());
            if (effectLevel > 3)
                g.setColor(new Color(1f,0f,0f,s));
            else
                g.setColor(new Color(1f,0f,0f));
            g.drawOval(x-r,y-r,r*2,r*2);
            dir.scale(s * 5 * DataManager.BLOCKSIZE);
            int rx,ry;
            rx = (int) (dir.x);
            ry = (int) (dir.y);
            g.drawLine(x-rx, y-ry, x+rx, y+ry);
            g.drawLine(x+rx, y-ry, x-rx, y+ry);
            dir.rotate(Math.PI/2);
            rx = (int) (dir.x);
            ry = (int) (dir.y);
            g.drawLine(x-rx, y-ry, x+rx, y+ry);
            g.drawLine(x+rx, y-ry, x-rx, y+ry);
        }
    }
    @Override
    public boolean isFinish(long currenttime)
    {
        return (currenttime - getStartTime() >= 30000 || !getTarget().isState(BodyPlayer.STATE_FIERCEATTACK));
    }
}