/*
 * 作成日: 2007/01/04
 */
package bakutan.game.deathmatch;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.geom.Area;
import java.awt.geom.Ellipse2D;

import bakutan.common.Body;
import bakutan.common.DataManager;
import bakutan.common.graphics.EffectDrawer;
import bakutan.common.math.BVector2f;

public class EffectFlush extends EffectDrawer
{
    public static final int RING_WIDTH = 5;
    public static double LINE_ANGLE = Math.PI /12;
    public static int LINE_NUM = 5;
    private Area ring;
    private Ellipse2D innerEllipse;
    private Ellipse2D outerEllipse;
    private Polygon[] lines;
    private float size; 
    private boolean lineDrawed;
    private int[][] pxs = new int[LINE_NUM][3];
    private int[][] pys = new int[LINE_NUM][3];

    
    public EffectFlush(Body target, long currenttime, float size)
    {
        super(currenttime, target);
        this.size = size;
        setLastUpdate(currenttime);
        setPosition(target.getPosition());
        setVelocity(target.getVelocity());
        innerEllipse = new Ellipse2D.Float();
        outerEllipse = new Ellipse2D.Float();
//        ring = new Area();
//        ring.add(new Area(outerEllipse));
//        ring.subtract(new Area(innerEllipse));
        lineDrawed = false;
    }
    @Override
    public void drawCharacter(Graphics g, long currenttime, int effectLevel)
    {
        int x = 0;
        int y = 0;

        long time = currenttime - getStartTime();
        float s;
        s = (float)time / 200f;
        
        if (!lineDrawed)
        {
            lineDrawed = true;
            BVector2f vec = new BVector2f(0,size);
            for (int i=0;i<LINE_NUM;i++)
            {
                pxs[i][0] = x;
                pys[i][0] = y;
                vec.rotate(Math.random() * 2 * Math.PI);
                pxs[i][1] = x + (int)(vec.x * DataManager.BLOCKSIZE);
                pys[i][1] = y + (int)(vec.y * DataManager.BLOCKSIZE);
                vec.rotate(LINE_ANGLE * Math.random());
                pxs[i][2] = x + (int)(vec.x * DataManager.BLOCKSIZE);
                pys[i][2] = y + (int)(vec.y * DataManager.BLOCKSIZE);
            }
        }
        if (effectLevel > 3)
            g.setColor(new Color(1f,1f,0f,1f-s));
        else
            g.setColor(new Color(1f,1f,0f));
            
        for (int i=0;i<LINE_NUM;i++)
        {
            g.fillPolygon(pxs[i],pys[i],3);
        }
        
        if (time <= 200)
        {
            if (effectLevel > 3)
                g.setColor(new Color(1f,1f,0f,1f-s));
            else
                g.setColor(new Color(1f,1f,0f));
            int r = (int)(DataManager.BLOCKSIZE * size * s);
            //innerEllipse.setFrame(x-r,y-r,r*2,r*2);
            innerEllipse.setFrame(outerEllipse.getX(), outerEllipse.getY(), outerEllipse.getWidth(), outerEllipse.getHeight());
            r += RING_WIDTH*2;
            outerEllipse.setFrame(x-r,y-r,r*2,r*2);
            ring = new Area();
            ring.add(new Area(outerEllipse));
            ring.subtract(new Area(innerEllipse));
            Graphics2D g2 = (Graphics2D)g;
            g2.fill(ring);
        }
    }
    @Override
    public boolean isFinish(long currenttime)
    {
        return (currenttime - getStartTime() >= 100);
    }
}