/*
 * 作成日: 2007/01/04
 */
package bakutan.game.deathmatch;

import java.awt.Color;
import java.awt.Graphics;

import bakutan.common.Body;
import bakutan.common.DataManager;
import bakutan.common.graphics.EffectDrawer;

public class EffectHealth extends EffectDrawer
{
    public static final int ARMOR = 0;
    public static final int DAMAGE = 1;
    public static final int ITEM = 2;
    private int type;
    
    public EffectHealth(Body target, int type, long currenttime)
    {
        super(currenttime,target);
        this.type = type;
        setLastUpdate(currenttime);
        setPosition(target.getPosition());
        setVelocity(target.getVelocity());
    }
    @Override
    public void drawCharacter(Graphics g, long currenttime, int effectLevel)
    {
        long time = currenttime - getStartTime();
        int x = 0;
        int y = 0;
        float s = (float)time / 400f;
        int r = (int)(DataManager.BLOCKSIZE * (s + 0.25f));
        if (effectLevel >= 3)
        {
            if (type == DAMAGE)
                g.setColor(new Color(1,0,0,1-s));
            else if (type == ARMOR)
                g.setColor(new Color(0,0,1,1-s));
            else if (type == ITEM)
                g.setColor(new Color(0,1,0,1-s));
        }
        else
        {
            if (type == DAMAGE)
                g.setColor(new Color(1,0,0,1));
            else if (type == ARMOR)
                g.setColor(new Color(0,0,1,1));
            else if (type == ITEM)
                g.setColor(new Color(0,1,0,1));
        }
        g.fillOval(x-r,y-r,r*2,r*2);
    }
    @Override
    public boolean isFinish(long currenttime)
    {
        return (currenttime - getStartTime() >= 400);
    }
}