/*
 * 作成日: 2007/01/04
 */
package bakutan.game.deathmatch;

import java.awt.AlphaComposite;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;

import bakutan.common.DataManager;
import bakutan.common.graphics.CharacterImage;
import bakutan.common.graphics.EffectDrawer;
import bakutan.common.math.BVector2f;

public class EffectSmoke extends EffectDrawer
{
    private CharacterImage characteImage;
    
    public EffectSmoke(BVector2f position, BVector2f velocity, long currenttime, CharacterImage cib)
    {
        super(currenttime);
        setLastUpdate(currenttime);
        setPosition(position);
        setVelocity(velocity);
        this.characteImage = cib;
    }
    @Override
    public void drawCharacter(Graphics g, long currenttime, int effectLevel)
    {
        long time = currenttime - getStartTime();
        float s = (float)time / 1000f;
        int x = 0;
        int y = 0;
        int r = (int)(DataManager.BLOCKSIZE * (s)) + 1;
        if (effectLevel >= 3)
        {
            Graphics2D g2 = (Graphics2D)g;
            Composite oldac = g2.getComposite();
            AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 1-s);
            g2.setComposite(ac);
            g2.drawImage(this.characteImage.getImages(0)[0], x-r,y-r,x+r,y+r,0,0,this.characteImage.getWidth(),this.characteImage.getHeight(), null);
            g2.setComposite(oldac);
        }
        else
        {
            g.drawImage(this.characteImage.getImages(0)[0], x-r,y-r,x+r,y+r,0,0,this.characteImage.getWidth(),this.characteImage.getHeight(), null);
        }
    }
    @Override
    public boolean isFinish(long currenttime)
    {
        return (currenttime - getStartTime() >= 1000);
    }
}