/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

/*
 * 作成日: 2005/02/13
 */
package bakutan.server;

import java.util.LinkedList;
import java.util.List;

import bakutan.common.BotInfo;
import bakutan.common.DataManager;

/**
 * @author cattaka
 */
public class BStageInfo
{
	private String bstageClassName;
	private String mapFileName;
	private int port;
    private String label = "";
	private String loginMessage = "";
	private int timeout = DataManager.DEFAULT_TIMEOUT;
	private long timeLimit = DataManager.DEFAULT_TIMELIMIT;
	private int maxClients = DataManager.DEFAULT_MAXCLIENTS;
    private boolean checkCheat = false;
    private List<BotInfo> botInfos = new LinkedList<BotInfo>();
    
	public BStageInfo(String bstageClassName, String bstageFileName, int port, String label, String loginMessage, boolean checkCheat)
	{
		this.bstageClassName = bstageClassName;
		this.mapFileName = bstageFileName;
		this.port = port;
        this.label = label;
		this.loginMessage = loginMessage;
		this.checkCheat = checkCheat;
	}

	public String getBstageClassName()
	{
		return bstageClassName;
	}
	public String getMapFileName()
	{
		return mapFileName;
	}
	public int getPort()
	{
		return port;
	}
	public String getLoginMessage()
	{
		return loginMessage;
	}
	public int getTimeout()
	{
		return timeout;
	}
	public void setTimeout(int timeout)
	{
		this.timeout = timeout;
	}
	public boolean isCheckCheat()
	{
		return checkCheat;
	}
	public long getTimeLimit()
	{
		return timeLimit;
	}
	public void setTimeLimit(long timeLimit)
	{
		this.timeLimit = timeLimit;
	}
	public int getMaxClients()
	{
		return maxClients;
	}
	public void setMaxClients(int maxClients) {
		this.maxClients = maxClients;
	}

    public String getLabel()
    {
        return label;
    }

    public void setLabel(String label)
    {
        this.label = label;
    }

    public void setBstageClassName(String bstageClassName)
    {
        this.bstageClassName = bstageClassName;
    }

    public void setCheckCheat(boolean checkCheat)
    {
        this.checkCheat = checkCheat;
    }

    public void setLoginMessage(String loginMessage)
    {
        this.loginMessage = loginMessage;
    }

    public void setMapFileName(String mapFileName)
    {
        this.mapFileName = mapFileName;
    }

    public void setPort(int port)
    {
        this.port = port;
    }

    public List<BotInfo> getBotInfos()
    {
        return botInfos;
    }
}
