/*
 * Copyright 2005 Takao Sumitomo. All rights reserved.
 * 
 * Redistribution and use in source and binary forms,
 * with or without modification, are permitted provided 
 * that the following conditions are met:
 *
 *   1. Redistributions of source code must retain the 
 *      above copyright notice, this list of conditions
 *      and the following disclaimer.
 *   2. Redistributions in binary form must reproduce 
 *      the above copyright notice, this list of conditions
 *      and the following disclaimer in the documentation
 *      and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software
 * and documentation are those of the authors and should not be
 * interpreted as representing official policies,
 * either expressed or implied.
 * 
 * @Author: Takao Sumitomo
 */

package bakutan.server;

import bakutan.common.DataManager;
import bakutan.common.serverinfo.ServerInfoManagerAddress;

/*
 * 作成日: 2004/10/11
 */

/**
 * @author cattaka
 */
public class ServerConfigurationInfo
{
    //private ArrayList<BStageInfo> bstageInfoList = new ArrayList<BStageInfo>();
	private DataBaseInfo dataBaseInfo;
    private ServerInfoManagerAddress serverInfoManagerAddress;
    private BStageInfo bStageInfo;
    private boolean registerServer = false;
    private boolean useUPNP = false;

	public ServerConfigurationInfo()
	{
        serverInfoManagerAddress = new ServerInfoManagerAddress(DataManager.DEFAULT_SERVER, DataManager.DEFAULT_SIMA_PORT);
	}
//	public boolean put(BStageInfo bstageInfo)
//	{
//		return bstageInfoList.add(bstageInfo);
//	}
//	public BStageInfo[] getBStageInfos()
//	{
//		BStageInfo[] bis = new BStageInfo[bstageInfoList.size()];
//		System.arraycopy(bstageInfoList.toArray(), 0, bis, 0, bis.length);
//		return bis;
//	}
    
    public DataBaseInfo getDataBaseInfo()
    {
        return dataBaseInfo;
    }
    public void setDataBaseInfo(DataBaseInfo dataBaseInfo)
    {
        this.dataBaseInfo = dataBaseInfo;
    }
    public ServerInfoManagerAddress getServerInfoManagerAddress()
    {
        return serverInfoManagerAddress;
    }
    public void setServerInfoManagerAddress(
            ServerInfoManagerAddress serverInfoManagerAddress)
    {
        this.serverInfoManagerAddress = serverInfoManagerAddress;
    }
    public BStageInfo getBStageInfo()
    {
        return bStageInfo;
    }
    public void setBStageInfo(BStageInfo stageInfo)
    {
        bStageInfo = stageInfo;
    }
    public boolean isRegisterServer()
    {
        return registerServer;
    }
    public void setRegisterServer(boolean registerServer)
    {
        this.registerServer = registerServer;
    }
    public boolean isUseUPNP()
    {
        return useUPNP;
    }
    public void setUseUPNP(boolean useUPNP)
    {
        this.useUPNP = useUPNP;
    }
    
}
