/*
 * 作成日: 2007/01/31
 */
package bakutan.server.util;

import bakutan.common.BUserInterface;

public abstract class NetworkTool
{
    abstract public boolean isSupportUPNP();
    abstract public String getLocalHostIP();
    abstract public int addPortMapping(int internalPort, BUserInterface userInterface);
    abstract public boolean deletePortMapping(int internalPort, BUserInterface userInterface);
    public static NetworkTool getAvailableNetworkTool()
    {
        try
        {
            Class implementNetworkToolClass = Class.forName("bakutan.server.util.ImplementNetworkTool");
            NetworkTool networkTool = (NetworkTool)implementNetworkToolClass.newInstance();
            return networkTool;
        }
        catch(ClassCastException e)
        {
        }
        catch(ClassNotFoundException e)
        {
        }
        catch(IllegalAccessException e)
        {
        }
        catch(InstantiationException e)
        {
        }
        return new NullNetworkTool();
    }
}
