/*
 * 作成日: 2007/01/31
 */
package bakutan.server.util;

import java.io.IOException;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.util.Enumeration;

import bakutan.common.BUserInterface;

public class NullNetworkTool extends NetworkTool
{
    public boolean isSupportUPNP()
    {
        return false;
    }
    public String getLocalHostIP()
    {
        try
        {
            String localHostIP;
            {
                NetworkInterface ni = NetworkInterface.getByName("eth0");
                Enumeration<InetAddress> enu = ni.getInetAddresses();
                if (enu.hasMoreElements())
                {
                    localHostIP = ni.getInetAddresses().nextElement().getHostAddress();
                }
                else
                {
                    localHostIP = InetAddress.getLocalHost().getHostAddress();
                }
            }
            return localHostIP;
        }
        catch(IOException e)
        {
            e.printStackTrace();
        }
        return null;
    }
    public int addPortMapping(int internalPort, BUserInterface userInterface)
    {
        return internalPort;
    }
    public boolean deletePortMapping(int internalPort, BUserInterface userInterface)
    {
        return false;
    }
}
